/*
 * Created by SharpDevelop.
 * User: Andrea
 * Date: 11/1/2004
 * Time: 8:46 PM
 *
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

/*
 * Created by SharpDevelop.
 * User: Omnibrain
 * Date: 01.11.2004
 * Time: 12:03
 *
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using DGNetwork.Services;
using ICSharpCode.Core.AddIns;
using System.Windows.Forms;

namespace AddInScout
{
	/// <summary>
	/// Description of AddinTreeView.
	/// </summary>
	public class TreeTreeView : Panel
	{
		public TreeView treeView = new TreeView();
		
		public TreeTreeView()
		{
			PopulateTreeView();
			
			treeView.ImageList = new ImageList();
			treeView.ImageList.ColorDepth = ColorDepth.Depth32Bit;
			AddImages(treeView.ImageList);
			treeView.Dock = DockStyle.Fill;
			Controls.Add(treeView);
		}
		
		public static void AddImages(ImageList imagelist)
		{
			imagelist.Images.Add(Service.Resource.GetBitmap("Icons.Class"));
			imagelist.Images.Add(Service.Resource.GetBitmap("Icons.Book"));
			imagelist.Images.Add(Service.Resource.GetBitmap("Icons.OpenBook"));
			imagelist.Images.Add(Service.Resource.GetBitmap("Icons.ClosedFolder"));
			imagelist.Images.Add(Service.Resource.GetBitmap("Icons.OpenFolder"));
		}
		
		void PopulateTreeView()
		{
			TreeNode rootNode = new TreeNode("AddInTree");
			rootNode.ImageIndex = rootNode.SelectedImageIndex = 0;
			rootNode.Expand();
			
			treeView.Nodes.Add(rootNode);
			
			IAddInTree at = AddInTreeSingleton.AddInTree;
			AddInCollection ac = at.AddIns;
			for (int i = 0; i < ac.Count; i++) {
				GetExtensions(ac[i], rootNode);
//				rootNode.Nodes.Add(newNode);
			}
		}
		
		void GetExtensions(AddIn ai, TreeNode treeNode)
		{
			foreach (AddIn.Extension ext in ai.Extensions) {
				string[] name = ext.Path.Split('/');
				TreeNode currentNode = treeNode;
				if (name.Length < 1) {
					continue;
				}
				for (int i = 1; i < name.Length; ++i) {
					bool found = false;
					foreach (TreeNode n in currentNode.Nodes) {
						if (n.Text == name[i]) {
							currentNode = n;
							found = true;
							break;
						}
					}
					if (found) {
						if (i == name.Length - 1 && currentNode.Tag == null)
							currentNode.Tag = ext;
					} else {
						TreeNode newNode = new TreeNode(name[i]);
						newNode.ImageIndex = 3;
						newNode.SelectedImageIndex = 4;
						if (i == name.Length - 1) {
							newNode.Tag = ext;
						}
						currentNode.Nodes.Add(newNode);
						currentNode = newNode;
					}
				}
			}
		}
	}
}
