// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Windows.Forms;
using DGNetwork.Chat;
using DGNetwork.Services;

namespace DGNetwork.AddIns.Browser
{
	public class IEDisplayFactory : DefaultDisplayFactory
	{
		public IEDisplayFactory()
		{
			this.Name = "IEDisplay";
			this.Title = "Internet Explorer";
		}
		
		public override IDisplay Create()
		{
			return new IEDisplay();
		}
	}
	
	public class IEDisplay : BrowserDisplay
	{
		IEBrowser browser;
		
		public IEDisplay()
		{
			browser = new IEBrowser();
			browser.Display = this;
			browser.Navigate(this.URL);
		}
		
		public override Control Control {
			get {
				return browser;
			}
		}
	}
}
