// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using ICSharpCode.Core.AddIns.Codons;
using Microsoft.Win32;

namespace DGNetwork.AddIns.Browser
{
	public class MaxConnectionsPerServerCheck : AbstractCommand
	{
		const string keyName = @"Software\Microsoft\Windows\CurrentVersion\Internet Settings";
		const string valueName = "MaxConnectionsPerServer";
		
		/// <summary>
		/// Run startup check.
		/// </summary>
		public override void Run()
		{
			using (RegistryKey key = Registry.CurrentUser.OpenSubKey(keyName, true)) {
				int oldValue = (int)key.GetValue(valueName, 2);
				if (oldValue < 5)
					key.SetValue(valueName, 6);
			}
		}
		
		/*
		static int windowCount;
		static int limit;
		
		public bool OpenWindow()
		{
			lock (typeof(MaxConnectionsPerServerCheck)) {
				if (windowCount + 2 >= limit)
					return false;
				using (RegistryKey key = Registry.CurrentUser.OpenSubKey(keyName, true)) {
					int oldValue = (int)key.GetValue(valueName, 2);
					
int dispValue=oldValue-1;
if (MessageBox.Show(string.Format(
"Die maximale Anzahl der Verbindungen ihrer Browsers mit dem Chat ist {0}.\r\n"+
"Um dieses Chatfenster zu öffnen, benötigen Sie mehr Verbindungen. Soll die"+
" Einstellung Ihrer Browsers entsprechend angepasst werden?",dispValue.ToString()),
"Anzahl Verbindungen",MessageBoxButtons.YesNo,MessageBoxIcon.Question)
					
					if (windowCount + 2 >= oldValue) {
						key.SetValue(keyName, oldValue + 2);
						limit = oldValue;
						// we need to restart DG Network to allow the new value to take effect
MessageBox.Show("Die Änderung wird erst nach einem Neustart von DG Network wirksam!","Anzahl Verbindungen");
						return false;
					} else {
						windowCount += 1;
						return true;
					}
				}
			}
		}
		
		public void CloseWindow()
		{
			lock (typeof(MaxConnectionsPerServerCheck)) {
				windowCount -= 1;
			}
		}
		*/
	}
}
