// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using DGNetwork.Contacts;
using DGNetwork.AddIns.Codons;
using DGNetwork.Services;
using DGNetwork.DGN.MUC;

namespace DGNetwork.AddIns.Discovery
{
	public class ShowProfileCommand : AbstractMenuCommand
	{
		public override void Run()
		{
			if (this.Owner is DiscoveryContact)
				Service.Browser.OpenWindow(URLs.ViewProfile + "?userid=" + ((DiscoveryContact)this.Owner).DiscoveryID.ToString(System.Globalization.NumberFormatInfo.InvariantInfo));
			else
				((DiscoverySearchResult)this.Owner).DoubleClick();
		}
	}
	
	public class AddToContactsCommand : AbstractMenuCommand
	{
		public override void Run()
		{
			((DiscoverySearchResult)this.Owner).AddToList();
		}
	}
	
	public class SendMessageCommand : AbstractMenuCommand
	{
		public override void Run()
		{
			((IContact)this.Owner).DoubleClick();
		}
	}
	
	public class CreateMultiUserChatCommand : AbstractMenuCommand
	{
		public override void Run()
		{
			DiscoveryContact contact = (DiscoveryContact)this.Owner;
			MUCRoom room = MUCService.CreateRoom(contact.User);
			if (room != null)
				Service.Chat.OpenChat(room, true);
		}
	}
}
