// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Text;
using DGNetwork.DGN;
using DGNetwork.Services;
using ICSharpCode.Core.Services;

namespace DGNetwork.AddIns.Discovery
{
	public class Properties
	{
		public static string Username {
			get {
				return Service.Property.GetProperty("Discovery.Username", "");
			}
			set {
				Service.Property.SetProperty("Discovery.Username", value.Trim());
				if (Service.Chat.Nickname == "")
					Service.Chat.Nickname = value.Trim();
				if (LoginChanged != null)
					LoginChanged(null, EventArgs.Empty);
			}
		}
		
		public static string Password {
			get {
				string base64 = Service.Property.GetProperty("Discovery.Password", "");
				if (base64 == "")
					return "";
				return Encoding.UTF8.GetString(Convert.FromBase64String(base64));
			}
			set {
				Service.Property.SetProperty("Discovery.Password", Convert.ToBase64String(Encoding.UTF8.GetBytes(value.Trim())));
				if (LoginChanged != null)
					LoginChanged(null, EventArgs.Empty);
			}
		}
		
		public static int UserID {
			get {
				return Service.Property.GetProperty("Discovery.UserID", 0);
			}
			set {
				Service.Property.SetProperty("Discovery.UserID", value);
			}
		}
		
		public static event EventHandler LoginChanged;
		
		public static Network Network;
	}
}
