// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Collections;
using System.Collections.Specialized;
using Grunwald.Gui.Settings;

using DGNetwork.Settings;
using DGNetwork.Services;
using DGNetwork.DGN;

namespace DGNetwork.AddIns.Discovery
{
	/// <summary>
	/// A setting page representing the official dg network.
	/// </summary>
	public class SettingPage : AbstractNetworkPage
	{
		[Setting("customsetting")]
		SpecialEditorSetting s = new SpecialEditorSetting("customsetting", "", "");
		
		Network network;
		
		public SettingPage()
		{
			s.EditorType = typeof(CustomSetting);
			this.DynamicPage = false;
			this.Title = "${res:Discovery.MainNetworkTitle}";
		}
		
		public override void CreateNetwork()
		{
			if (network != null)
				throw new InvalidOperationException();
			network = new Network("DG Network");
			Properties.Network = network;
			network.IpServer.Add(new DiscoveryServer(network));
			Service.DGN.RegisterNetwork(network);
		}
		
		public override void DestroyNetwork()
		{
			if (network == null)
				throw new InvalidOperationException();
			Service.DGN.RemoveNetwork(network);
			network = null;
		}
	}
}
