// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Xml;
using System.Windows.Forms;
using DGNetwork.Services;
using DGNetwork.Gui;
using ICSharpCode.Core.Services;

namespace DGNetwork.AddIns.Discovery
{
	public class Wizard : AbstractWizard
	{
		bool forceRun = false;
		
		public Wizard() : this(false) {}
		
		public Wizard(bool forceRun)
		{
			this.forceRun = forceRun;
		}
		
		int page = 0;
		
		public int Page {
			get {
				return page;
			}
			set {
				page = value;
			}
		}
		
		DiscoveryWizard discWizard;
		
		public override void ShowOn(IWizardContainer container)
		{
			if (!forceRun && Properties.UserID > 0) {
				container.NextWizard();
				return;
			}
			base.ShowOn(container);
			container.Title = "${res:Discovery.RegisterTitle}";
			discWizard = new DiscoveryWizard();
			discWizard.wizard = this;
			XmlControl ctl = new XmlControl("DiscoveryWizard", discWizard);
			container.SetControl(ctl.Control);
			container.NextEnabled = false;
		}
		
		public override void Next()
		{
			if (page == 0) {
				discWizard.Next();
			} else {
				SkipRegister();
			}
		}
		
		public void SkipRegister()
		{
			if (Service.Message.AskQuestion("${res:Discovery.SkipRegistrationQuestion}", "${res:Discovery.SkipRegistration}"))
				Container.NextWizard();
		}
		
		public override void Back()
		{
			page = 0;
			this.ShowOn(this.Container);
			discWizard.newAccountButton.Checked = true;
			discWizard.newAccountButton.PerformClick();
		}
	}
}

