<?php
// THIS IS NOT THE "STANDARD" IP SERVER CODE, BUT THE CODE USED TO CONNECT TO
// AN IP SERVER USING A PHPBB FORUM TO AUTHORIZE IT'S USERS!

// Table changes needed to a default phpBB user table:
/*
ALTER TABLE phpbb_users ADD COLUMN dgn_ip INT NOT NULL;
ALTER TABLE phpbb_users ADD COLUMN dgn_port SMALLINT UNSIGNED NOT NULL;
ALTER TABLE phpbb_users ADD COLUMN dgn_lastaccess INT NOT NULL;
 );
*/

/////////////////////////////////
////     Configuration       ////
/////////////////////////////////

$correctIdentifier = "DG Network"; // you have to change this line to use the identifier you have choosen for your network

// the connectKey is used by the clients to make sure that no one who has not connected to the IP-Server can connect to the network
// the actual key used is encrypted and changes in the specified interval; but if someone can guess this string, he can calculate the encrypted key on his own.
// the key must be identical on all IP Servers and requires to have the same date on the servers.
$connectKey = "OfficialTopSecretKey";
$keychange = "W"; // "m"=montly "W" = Weekly, "d" = daily, "" = every year


// Advanced properties, edit only when you know what you are doing.

// all times are in seconds
$serverRefreshTime = 250; // time after which the clients that are hosts should refresh this page
$clientRefreshTime = 450; // time after which the clients that aren't hosts should refresh this page
$serverDeadTime = 600; // time after which a server is interpreted as offline
$clientDeadTime = 1000; // time after which a client is interpreted as offline
// the DeadTimes should be at least the double of the refresh time

$deleteUserTime = 3600 * 24 * 7; // time after which the user entry is deleted

$minServerCount = 3; // number of servers the network should have at least. If the server count is below this value, the "wantmore"-Attribute is sent.
$sendServerCount = 15; // this is the maximal number of hosts send to the client

$connectSecureKey = md5($connectKey . date("Y$keychange") . $correctIdentifier);
// the connectSecureKey is used by the clients to make sure that no one who has not connected to the IP-Server can connect to the network
// in connection with date the key is changed every day/month.
// Keep the string secret so the key cannot be calculated for other days/months!!!

/////////////////////////////////
////    Initialize Script    ////
/////////////////////////////////
header('Content-Type: text/xml');

function die_error($text) {
	echo "<error>$text</error></dgnipserver>";
	exit;
}

define('IN_PHPBB', true);
$phpbb_root_path = '../../forum/';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

echo "<" . '?xml version="1.0" encoding="iso-8859-1"?'. ">";
mt_srand ((double)microtime()*1000000);
$now = time();
echo "<dgnipserver>";

/////////////////////////////////
////      Get Parameters     ////
/////////////////////////////////
// Mandatory parameters:
// pwd=password  # the password used for saving the uid
//   # password is clear text (plain ascii) or somehow encoded, the client may choose
//   # password in database is sha1-coded
//
// Optional parameters:
// uid=id                  # the user-id the client wants to use
// port=(0|port)           # the port where dg network listens as server
// identifier=identifier # the identifier expected for this server. a wrong identifier causes an error.
//   # when port is 0, the user cannot be server.
if (!isset($_GET['pwd'])) {
	die_error("The needed attribute 'pwd' was not specified. This page is intended for use with the DG Network chat program.\n" .
	          "If you are viewing it in a browser, goto http://www.danielgrunwald.de/network/ for more information.");
}
$password = $_GET['pwd'];

if (isset($_GET['username'])) {
	$uid = 0;
	$username = phpbb_clean_username($_GET['username']);
} else {
	$username = '';
	if (isset($_GET['uid'])) {
		$uid = (int)$_GET['uid'];
		if ($uid < 0)
			$uid = 0;
	} else {
		$uid = 0;
	}
}
if ($username == '' && $uid == 0) {
	die_error("The needed attribute 'username' was not specified. This page is intended for use with the DG Network chat program.\n" .
	          "If you are viewing it in a browser, goto http://www.danielgrunwald.de/network/ for more information.");
}
if (isset($_GET['port'])) {
	$port = (int)$_GET['port'];
	if ($port < 0)
		$port = 0;
} else {
	$port = 0;
}
if (isset($_GET['identifier'])) {
	if ($_GET['identifier'] != $correctIdentifier)
		die_error("The specified identifier is not accepted on this server.");
}


/////////////////////////////////
////   Get user information  ////
/////////////////////////////////

$sql = "SELECT user_id, username, user_password, user_active, user_level
	FROM " . USERS_TABLE . " WHERE ";
if ($uid == 0) {
	$sql .= "username = '" . str_replace("\\'", "''", $username) . "'";
} else {
	$sql .= "user_id = $uid";
}

if (!($result = $db->sql_query($sql))) {
	die_error('Unknown SQL error in user query.');
}

if ($row = $db->sql_fetchrow($result)) {
	if (md5($password) == $row['user_password']) {
		if (!$row['user_active'])
			die_error("Der Benutzeraccount ist nicht aktiviert.");
		
	} else {
		die_error("Das Passwort ist falsch.");
	}
} else {
	die_error("Es existiert kein Benutzer mit dem angegebenen Namen.");
}

$username = $row['username'];

$uid = $row['user_id'];
$db->sql_freeresult($result);

/////////////////////////////////
//// Update user information ////
/////////////////////////////////
$iplong = ip2long($_SERVER["REMOTE_ADDR"]);
$sql = "UPDATE " . USERS_TABLE . " "
	. "SET dgn_ip = '$iplong', "
	.   "dgn_port = '$port', "
	.  "dgn_lastaccess = '$now' "
	. "WHERE user_id = '$uid';";
if (!($result = $db->sql_query($sql))) {
	die_error('Unknown SQL error in update query.');
}

/////////////////////////////////
////    Send XML document    ////
/////////////////////////////////

$sql = "SELECT user_id, dgn_ip, dgn_port FROM " . USERS_TABLE
	. " WHERE (dgn_port > 0) "
	.   "AND (($now - dgn_lastaccess) < $serverDeadTime) "
	.   "AND (user_id != '$uid') "
	. "ORDER BY ($now - dgn_lastaccess) DESC "
	. "LIMIT 0,$sendServerCount;";
if (!($result = $db->sql_query($sql))) {
	die_error('Unknown SQL error in host query: ' . htmlspecialchars($sql));
}

?>
  <status>
    <ip><? echo $_SERVER["REMOTE_ADDR"]; ?></ip>
    <time><? echo $now; ?></time>
    <? if (!isset($_GET['identifier'])) echo "<identifier>$correctIdentifier</identifier>"; ?>
    <nextrefresh><? echo $serverRefreshTime; ?></nextrefresh>
<?
	if ($connectSecureKey != "") {
		print("  <connectkey>$connectSecureKey</connectkey>\n");
	}
	print("    <yourid>$uid</yourid>");
?>
  </status>
  <hosts>
<?
while($arr = $db->sql_fetchrow($result)) {
	$hostid = $arr['user_id'];
	$hostip = long2ip($arr['dgn_ip']);
	$hostport = $arr['dgn_port'];
	print("    <host userid=\"$hostid\">$hostip:$hostport</host>\n");
}
$db->sql_freeresult($result);
?>
  </hosts>
</dgnipserver>
