// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.ComponentModel;
using System.Text;
using DGNetwork.Services;
using ICSharpCode.Core.Services;

namespace DGNetwork.AddIns.History
{
	public enum LoggingMode
	{
		[Description("${res:History.Settings.DontSave}")]
		None,
		[Description("${res:History.Settings.ToText}")]
		ToText,
		[Description("${res:History.Settings.ToHtml}")]
		ToHtml
	}
	
	public sealed class Properties
	{
		public static LoggingMode Mode {
			get {
				return (LoggingMode)Service.Property.GetProperty("History.LoggingMode", LoggingMode.None);
			}
		}
		
		public static string Path {
			get {
				return (string)Service.Property.GetProperty("History.LogPath", string.Empty);
			}
		}
	}
}
