// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

// 
//      WARNING !
// This file has been autogenerated from a xml file. Do not change it, your changes
// will be overwritten!
//


using System;
using System.Collections;
using System.IO;

namespace Grunwald.NOscar
{
	#region SnacFactory
	public sealed class SnacFactory
	{
		public Snac CreateSnac(byte[] data, int index, int count)
		{
			ushort family = NetworkBitConverter.ToUInt16(data, index);
			ushort subType = NetworkBitConverter.ToUInt16(data, index + 2);
			if (family == KeyRequestSnac.SnacFamily && subType == KeyRequestSnac.SnacType)
				return new KeyRequestSnac(data, index, count);
			if (family == KeyResponseSnac.SnacFamily && subType == KeyResponseSnac.SnacType)
				return new KeyResponseSnac(data, index, count);
			if (family == AuthRequestSnac.SnacFamily && subType == AuthRequestSnac.SnacType)
				return new AuthRequestSnac(data, index, count);
			if (family == AuthResponseSnac.SnacFamily && subType == AuthResponseSnac.SnacType)
				return new AuthResponseSnac(data, index, count);
			if (family == ServerReadySnac.SnacFamily && subType == ServerReadySnac.SnacType)
				return new ServerReadySnac(data, index, count);
			if (family == ClientVersionsSnac.SnacFamily && subType == ClientVersionsSnac.SnacType)
				return new ClientVersionsSnac(data, index, count);
			if (family == ServerVersionsSnac.SnacFamily && subType == ServerVersionsSnac.SnacType)
				return new ServerVersionsSnac(data, index, count);
			if (family == MessageOfTheDaySnac.SnacFamily && subType == MessageOfTheDaySnac.SnacType)
				return new MessageOfTheDaySnac(data, index, count);
			if (family == RateInfoRequestSnac.SnacFamily && subType == RateInfoRequestSnac.SnacType)
				return new RateInfoRequestSnac(data, index, count);
			if (family == RateInfoSnac.SnacFamily && subType == RateInfoSnac.SnacType)
				return new RateInfoSnac(data, index, count);
			if (family == RateAckSnac.SnacFamily && subType == RateAckSnac.SnacType)
				return new RateAckSnac(data, index, count);
			if (family == IcbmRequestParameterInfoSnac.SnacFamily && subType == IcbmRequestParameterInfoSnac.SnacType)
				return new IcbmRequestParameterInfoSnac(data, index, count);
			if (family == IcbmParameterInfoSnac.SnacFamily && subType == IcbmParameterInfoSnac.SnacType)
				return new IcbmParameterInfoSnac(data, index, count);
			if (family == IcbmSetParameterInfoSnac.SnacFamily && subType == IcbmSetParameterInfoSnac.SnacType)
				return new IcbmSetParameterInfoSnac(data, index, count);
			if (family == LocationRightsRequestSnac.SnacFamily && subType == LocationRightsRequestSnac.SnacType)
				return new LocationRightsRequestSnac(data, index, count);
			if (family == LocationRightsSnac.SnacFamily && subType == LocationRightsSnac.SnacType)
				return new LocationRightsSnac(data, index, count);
			if (family == SsiRightsRequestSnac.SnacFamily && subType == SsiRightsRequestSnac.SnacType)
				return new SsiRightsRequestSnac(data, index, count);
			if (family == SsiRightsSnac.SnacFamily && subType == SsiRightsSnac.SnacType)
				return new SsiRightsSnac(data, index, count);
			if (family == SsiDataRequestSnac.SnacFamily && subType == SsiDataRequestSnac.SnacType)
				return new SsiDataRequestSnac(data, index, count);
			if (family == SsiDataSnac.SnacFamily && subType == SsiDataSnac.SnacType)
				return new SsiDataSnac(data, index, count);
			if (family == ActivateSsiSnac.SnacFamily && subType == ActivateSsiSnac.SnacType)
				return new ActivateSsiSnac(data, index, count);
			if (family == MyInfoRequestSnac.SnacFamily && subType == MyInfoRequestSnac.SnacType)
				return new MyInfoRequestSnac(data, index, count);
			if (family == ClientReadySnac.SnacFamily && subType == ClientReadySnac.SnacType)
				return new ClientReadySnac(data, index, count);
			if (family == OutgoingIcbmSnac.SnacFamily && subType == OutgoingIcbmSnac.SnacType)
				return new OutgoingIcbmSnac(data, index, count);
			if (family == IncomingIcbmSnac.SnacFamily && subType == IncomingIcbmSnac.SnacType)
				return new IncomingIcbmSnac(data, index, count);
			if (family == ImAckSnac.SnacFamily && subType == ImAckSnac.SnacType)
				return new ImAckSnac(data, index, count);
			if (family == SendTypingStateSnac.SnacFamily && subType == SendTypingStateSnac.SnacType)
				return new SendTypingStateSnac(data, index, count);
			if (family == IcqMetaInfoRequestSnac.SnacFamily && subType == IcqMetaInfoRequestSnac.SnacType)
				return new IcqMetaInfoRequestSnac(data, index, count);
			if (family == IcqMetaInfoResponseSnac.SnacFamily && subType == IcqMetaInfoResponseSnac.SnacType)
				return new IcqMetaInfoResponseSnac(data, index, count);
			return new DataSnac(data, index, count);
		}
	}
	#endregion
	
	#region KeyRequestSnac
	public sealed class KeyRequestSnac : TlvBasedSnac
	{
		/// <summary>The family id normally used for the KeyRequestSnac.</summary>
		public static ushort SnacFamily = 0x0017;
		/// <summary>The SNAC subtype normally used for the KeyRequestSnac.</summary>
		public static ushort SnacType = 0x0006;
		
		/// <summary>Creates a new KeyRequestSnac.</summary>
		/// <param name="screenName">The user's screenname.</param>
		public KeyRequestSnac(string screenName) : base(SnacFamily, SnacType)
		{
			this.ScreenName = screenName;
			this.Unknown1 = new byte[0];
			this.Unknown2 = new byte[0];
		}
		
		/// <summary>Loads the KeyRequestSnac from the byte array.</summary>
		public KeyRequestSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
		
		/// <summary>The user's screenname.</summary>
		public string ScreenName {
			get {
				return Chain.GetString(0x0001);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("screenName");
				Chain.SetString(0x0001, value);
			}
		}
		
		public byte[] Unknown1 {
			get {
				return Chain.GetData(0x004b);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("unknown1");
				Chain.SetData(0x004b, value);
			}
		}
		
		public byte[] Unknown2 {
			get {
				return Chain.GetData(0x005a);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("unknown2");
				Chain.SetData(0x005a, value);
			}
		}
	}
	#endregion
	
	#region KeyResponseSnac
	public sealed class KeyResponseSnac : Snac
	{
		/// <summary>The family id normally used for the KeyResponseSnac.</summary>
		public static ushort SnacFamily = 0x0017;
		/// <summary>The SNAC subtype normally used for the KeyResponseSnac.</summary>
		public static ushort SnacType = 0x0007;
		
		/// <summary>Creates a new KeyResponseSnac.</summary>
		public KeyResponseSnac(byte[] key) : base(SnacFamily, SnacType)
		{
			this.Key = key;
		}
		
		/// <summary>Loads the KeyResponseSnac from the byte array.</summary>
		public KeyResponseSnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.key = new byte[NetworkBitConverter.ToUInt16(data, pos)];
			pos += 2;
			for (int i = 0; i < this.key.Length; ++i) {
				this.key[i] = data[pos++];
			}
		}
		
		/// <summary>Gets the size of this KeyResponseSnac in bytes.</summary>
		public override int GetByteLength()
		{
			return base.GetByteLength() + 2 + key.Length * 1;
		}
		
		/// <summary>Writes the byte representation of the KeyResponseSnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			stream.Write(NetworkBitConverter.GetBytes((ushort)key.Length), 0, 2);
			foreach (byte a in key) {
				stream.WriteByte(a);
			}
		}
		
		byte[] key;
		
		public byte[] Key {
			get {
				return key;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("key");
				key = value;
			}
		}
	}
	#endregion
	
	#region AuthRequestSnac
	public sealed class AuthRequestSnac : TlvBasedSnac
	{
		/// <summary>The family id normally used for the AuthRequestSnac.</summary>
		public static ushort SnacFamily = 0x0017;
		/// <summary>The SNAC subtype normally used for the AuthRequestSnac.</summary>
		public static ushort SnacType = 0x0002;
		
		/// <summary>Creates a new AuthRequestSnac.</summary>
		/// <param name="screenName">The user's screenname.</param>
		public AuthRequestSnac(string screenName, byte[] encryptedPass) : base(SnacFamily, SnacType)
		{
			this.ScreenName = screenName;
			this.UserAgent = "ICQ Inc. - Product of ICQ (TM).2003b.5.56.1.3916.85";
			this.EncryptedPass = encryptedPass;
			this.ClientID = 0x010a;
			this.VersionMajor = 5;
			this.VersionMinor = 56;
			this.VersionPoint = 1;
			this.VersionBuild = 3916;
			this.DistributionCode = 85;
			this.Language = "en";
			this.Country = "us";
		}
		
		/// <summary>Loads the AuthRequestSnac from the byte array.</summary>
		public AuthRequestSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
		
		/// <summary>The user's screenname.</summary>
		public string ScreenName {
			get {
				return Chain.GetString(0x0001);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("screenName");
				Chain.SetString(0x0001, value);
			}
		}
		
		public string UserAgent {
			get {
				return Chain.GetString(0x0003);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("userAgent");
				Chain.SetString(0x0003, value);
			}
		}
		
		public byte[] EncryptedPass {
			get {
				return Chain.GetData(0x0025);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("encryptedPass");
				Chain.SetData(0x0025, value);
			}
		}
		
		public ushort ClientID {
			get {
				return Chain.GetShort(0x0016);
			}
			set {
				Chain.SetShort(0x0016, value);
			}
		}
		
		public ushort VersionMajor {
			get {
				return Chain.GetShort(0x0017);
			}
			set {
				Chain.SetShort(0x0017, value);
			}
		}
		
		public ushort VersionMinor {
			get {
				return Chain.GetShort(0x0018);
			}
			set {
				Chain.SetShort(0x0018, value);
			}
		}
		
		public ushort VersionPoint {
			get {
				return Chain.GetShort(0x0019);
			}
			set {
				Chain.SetShort(0x0019, value);
			}
		}
		
		public ushort VersionBuild {
			get {
				return Chain.GetShort(0x001a);
			}
			set {
				Chain.SetShort(0x001a, value);
			}
		}
		
		public uint DistributionCode {
			get {
				return Chain.GetInt(0x0014);
			}
			set {
				Chain.SetInt(0x0014, value);
			}
		}
		
		/// <summary>The language code (en, de, etc.).</summary>
		public string Language {
			get {
				return Chain.GetString(0x000f);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("language");
				Chain.SetString(0x000f, value);
			}
		}
		
		/// <summary>The country code (us, de, etc.).</summary>
		public string Country {
			get {
				return Chain.GetString(0x000e);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("country");
				Chain.SetString(0x000e, value);
			}
		}
	}
	#endregion
	
	#region AuthResponseSnac
	public sealed class AuthResponseSnac : TlvBasedSnac
	{
		/// <summary>The family id normally used for the AuthResponseSnac.</summary>
		public static ushort SnacFamily = 0x0017;
		/// <summary>The SNAC subtype normally used for the AuthResponseSnac.</summary>
		public static ushort SnacType = 0x0003;
		
		/// <summary>Creates a new AuthResponseSnac.</summary>
		/// <param name="screenName">The user's screenname.</param>
		/// <param name="server">Address and port of the BOS server.</param>
		public AuthResponseSnac(string screenName, string server, byte[] cookie, string eMail, ushort registrationStatus, AuthResponseErrorCode errorCode, string errorUrl) : base(SnacFamily, SnacType)
		{
			this.ScreenName = screenName;
			this.Server = server;
			this.Cookie = cookie;
			this.EMail = eMail;
			this.RegistrationStatus = registrationStatus;
			this.ErrorCode = errorCode;
			this.ErrorUrl = errorUrl;
		}
		
		/// <summary>Loads the AuthResponseSnac from the byte array.</summary>
		public AuthResponseSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
		
		/// <summary>The user's screenname.</summary>
		public string ScreenName {
			get {
				return Chain.GetString(0x0001);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("screenName");
				Chain.SetString(0x0001, value);
			}
		}
		
		/// <summary>Address and port of the BOS server.</summary>
		public string Server {
			get {
				return Chain.GetString(0x0005);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("server");
				Chain.SetString(0x0005, value);
			}
		}
		
		public byte[] Cookie {
			get {
				return Chain.GetData(0x0006);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("cookie");
				Chain.SetData(0x0006, value);
			}
		}
		
		public string EMail {
			get {
				return Chain.GetString(0x0011);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("eMail");
				Chain.SetString(0x0011, value);
			}
		}
		
		public ushort RegistrationStatus {
			get {
				return Chain.GetShort(0x0013);
			}
			set {
				Chain.SetShort(0x0013, value);
			}
		}
		
		public AuthResponseErrorCode ErrorCode {
			get {
				return (AuthResponseErrorCode)Chain.GetShort(0x0008);
			}
			set {
				Chain.SetShort(0x0008, (ushort)value);
			}
		}
		
		public string ErrorUrl {
			get {
				return Chain.GetString(0x0004);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("errorUrl");
				Chain.SetString(0x0004, value);
			}
		}
	}
	#endregion
	
	#region ServerReadySnac
	public sealed class ServerReadySnac : Snac
	{
		/// <summary>The family id normally used for the ServerReadySnac.</summary>
		public static ushort SnacFamily = 0x0001;
		/// <summary>The SNAC subtype normally used for the ServerReadySnac.</summary>
		public static ushort SnacType = 0x0003;
		
		/// <summary>Creates a new ServerReadySnac.</summary>
		public ServerReadySnac(ushort[] families) : base(SnacFamily, SnacType)
		{
			this.Families = families;
		}
		
		/// <summary>Loads the ServerReadySnac from the byte array.</summary>
		public ServerReadySnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.families = new ushort[(count + index - pos) / 2];
			for (int i = 0; i < this.families.Length; ++i) {
				this.families[i] = NetworkBitConverter.ToUInt16(data, pos);
				pos += 2;
			}
		}
		
		/// <summary>Gets the size of this ServerReadySnac in bytes.</summary>
		public override int GetByteLength()
		{
			return base.GetByteLength() + 0 + families.Length * 2;
		}
		
		/// <summary>Writes the byte representation of the ServerReadySnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			foreach (ushort a in families) {
				stream.Write(NetworkBitConverter.GetBytes(a), 0, 2);
			}
		}
		
		ushort[] families;
		
		public ushort[] Families {
			get {
				return families;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("families");
				families = value;
			}
		}
	}
	#endregion
	
	#region FamilyVersion
	public sealed class FamilyVersion : IByteConvertible
	{
		/// <summary>The FamilyVersion has always this size in bytes.</summary>
		public const int FixedSize = 2 + 2;
		
		/// <summary>Creates a new FamilyVersion.</summary>
		public FamilyVersion(ushort family, ushort version)
		{
			this.Family = family;
			this.Version = version;
		}
		
		/// <summary>Loads the FamilyVersion from the byte array.</summary>
		public FamilyVersion(byte[] data, int index, int count)
		{
			int pos = index;
			this.family = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.version = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
		}
		
		/// <summary>Gets the size of this FamilyVersion in bytes.</summary>
		public int GetByteLength()
		{
			return FixedSize;
		}
		
		/// <summary>Writes the byte representation of the FamilyVersion into the specified stream.</summary>
		public void WriteBytes(Stream stream)
		{
			stream.Write(NetworkBitConverter.GetBytes(family), 0, 2);
			stream.Write(NetworkBitConverter.GetBytes(version), 0, 2);
		}
		
		ushort family;
		
		public ushort Family {
			get {
				return family;
			}
			set {
				family = value;
			}
		}
		
		ushort version;
		
		public ushort Version {
			get {
				return version;
			}
			set {
				version = value;
			}
		}
	}
	#endregion
	
	#region ClientVersionsSnac
	public sealed class ClientVersionsSnac : Snac
	{
		/// <summary>The family id normally used for the ClientVersionsSnac.</summary>
		public static ushort SnacFamily = 0x0001;
		/// <summary>The SNAC subtype normally used for the ClientVersionsSnac.</summary>
		public static ushort SnacType = 0x0017;
		
		/// <summary>Creates a new ClientVersionsSnac.</summary>
		public ClientVersionsSnac(FamilyVersion[] versions) : base(SnacFamily, SnacType)
		{
			this.Versions = versions;
		}
		
		/// <summary>Loads the ClientVersionsSnac from the byte array.</summary>
		public ClientVersionsSnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.versions = new FamilyVersion[(count + index - pos) / FamilyVersion.FixedSize];
			for (int i = 0; i < this.versions.Length; ++i) {
				this.versions[i] = new FamilyVersion(data, pos, count + index - pos);
				pos += this.versions[i].GetByteLength();
			}
		}
		
		/// <summary>Gets the size of this ClientVersionsSnac in bytes.</summary>
		public override int GetByteLength()
		{
			return base.GetByteLength() + 0 + versions.Length * FamilyVersion.FixedSize;
		}
		
		/// <summary>Writes the byte representation of the ClientVersionsSnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			foreach (FamilyVersion a in versions) {
				a.WriteBytes(stream);
			}
		}
		
		FamilyVersion[] versions;
		
		public FamilyVersion[] Versions {
			get {
				return versions;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("versions");
				versions = value;
			}
		}
	}
	#endregion
	
	#region ServerVersionsSnac
	public sealed class ServerVersionsSnac : Snac
	{
		/// <summary>The family id normally used for the ServerVersionsSnac.</summary>
		public static ushort SnacFamily = 0x0001;
		/// <summary>The SNAC subtype normally used for the ServerVersionsSnac.</summary>
		public static ushort SnacType = 0x0018;
		
		/// <summary>Creates a new ServerVersionsSnac.</summary>
		public ServerVersionsSnac(FamilyVersion[] versions) : base(SnacFamily, SnacType)
		{
			this.Versions = versions;
		}
		
		/// <summary>Loads the ServerVersionsSnac from the byte array.</summary>
		public ServerVersionsSnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.versions = new FamilyVersion[(count + index - pos) / FamilyVersion.FixedSize];
			for (int i = 0; i < this.versions.Length; ++i) {
				this.versions[i] = new FamilyVersion(data, pos, count + index - pos);
				pos += this.versions[i].GetByteLength();
			}
		}
		
		/// <summary>Gets the size of this ServerVersionsSnac in bytes.</summary>
		public override int GetByteLength()
		{
			return base.GetByteLength() + 0 + versions.Length * FamilyVersion.FixedSize;
		}
		
		/// <summary>Writes the byte representation of the ServerVersionsSnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			foreach (FamilyVersion a in versions) {
				a.WriteBytes(stream);
			}
		}
		
		FamilyVersion[] versions;
		
		public FamilyVersion[] Versions {
			get {
				return versions;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("versions");
				versions = value;
			}
		}
	}
	#endregion
	
	#region MessageOfTheDaySnac
	public sealed class MessageOfTheDaySnac : Snac
	{
		/// <summary>The family id normally used for the MessageOfTheDaySnac.</summary>
		public static ushort SnacFamily = 0x0001;
		/// <summary>The SNAC subtype normally used for the MessageOfTheDaySnac.</summary>
		public static ushort SnacType = 0x0013;
		
		/// <summary>Creates a new MessageOfTheDaySnac.</summary>
		public MessageOfTheDaySnac(ushort motdType) : base(SnacFamily, SnacType)
		{
			this.MotdType = motdType;
		}
		
		/// <summary>Loads the MessageOfTheDaySnac from the byte array.</summary>
		public MessageOfTheDaySnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.motdType = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
		}
		
		/// <summary>Gets the size of this MessageOfTheDaySnac in bytes.</summary>
		public override int GetByteLength()
		{
			return base.GetByteLength() + 2;
		}
		
		/// <summary>Writes the byte representation of the MessageOfTheDaySnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			stream.Write(NetworkBitConverter.GetBytes(motdType), 0, 2);
		}
		
		ushort motdType;
		
		public ushort MotdType {
			get {
				return motdType;
			}
			set {
				motdType = value;
			}
		}
	}
	#endregion
	
	#region RateInfoRequestSnac
	public sealed class RateInfoRequestSnac : Snac
	{
		/// <summary>The family id normally used for the RateInfoRequestSnac.</summary>
		public static ushort SnacFamily = 0x0001;
		/// <summary>The SNAC subtype normally used for the RateInfoRequestSnac.</summary>
		public static ushort SnacType = 0x0006;
		
		/// <summary>Creates a new RateInfoRequestSnac.</summary>
		public RateInfoRequestSnac() : base(SnacFamily, SnacType)
		{
		}
		
		/// <summary>Loads the RateInfoRequestSnac from the byte array.</summary>
		public RateInfoRequestSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
	}
	#endregion
	
	#region RateClassInfo
	public sealed class RateClassInfo : IByteConvertible
	{
		/// <summary>The RateClassInfo has always this size in bytes.</summary>
		public const int FixedSize = 2 + 4 + 4 + 4 + 4 + 4 + 4 + 4;
		
		/// <summary>Creates a new RateClassInfo.</summary>
		public RateClassInfo(ushort rateClass, uint windowSize, uint clearAverage, uint warnAverage, uint limitedAverage, uint disconnectAverage, uint currentAverage, uint maximalAverage)
		{
			this.RateClass = rateClass;
			this.WindowSize = windowSize;
			this.ClearAverage = clearAverage;
			this.WarnAverage = warnAverage;
			this.LimitedAverage = limitedAverage;
			this.DisconnectAverage = disconnectAverage;
			this.CurrentAverage = currentAverage;
			this.MaximalAverage = maximalAverage;
		}
		
		/// <summary>Loads the RateClassInfo from the byte array.</summary>
		public RateClassInfo(byte[] data, int index, int count)
		{
			int pos = index;
			this.rateClass = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.windowSize = NetworkBitConverter.ToUInt32(data, pos);
			pos += 4;
			this.clearAverage = NetworkBitConverter.ToUInt32(data, pos);
			pos += 4;
			this.warnAverage = NetworkBitConverter.ToUInt32(data, pos);
			pos += 4;
			this.limitedAverage = NetworkBitConverter.ToUInt32(data, pos);
			pos += 4;
			this.disconnectAverage = NetworkBitConverter.ToUInt32(data, pos);
			pos += 4;
			this.currentAverage = NetworkBitConverter.ToUInt32(data, pos);
			pos += 4;
			this.maximalAverage = NetworkBitConverter.ToUInt32(data, pos);
			pos += 4;
		}
		
		/// <summary>Gets the size of this RateClassInfo in bytes.</summary>
		public int GetByteLength()
		{
			return FixedSize;
		}
		
		/// <summary>Writes the byte representation of the RateClassInfo into the specified stream.</summary>
		public void WriteBytes(Stream stream)
		{
			stream.Write(NetworkBitConverter.GetBytes(rateClass), 0, 2);
			stream.Write(NetworkBitConverter.GetBytes(windowSize), 0, 4);
			stream.Write(NetworkBitConverter.GetBytes(clearAverage), 0, 4);
			stream.Write(NetworkBitConverter.GetBytes(warnAverage), 0, 4);
			stream.Write(NetworkBitConverter.GetBytes(limitedAverage), 0, 4);
			stream.Write(NetworkBitConverter.GetBytes(disconnectAverage), 0, 4);
			stream.Write(NetworkBitConverter.GetBytes(currentAverage), 0, 4);
			stream.Write(NetworkBitConverter.GetBytes(maximalAverage), 0, 4);
		}
		
		ushort rateClass;
		
		public ushort RateClass {
			get {
				return rateClass;
			}
			set {
				rateClass = value;
			}
		}
		
		uint windowSize;
		
		public uint WindowSize {
			get {
				return windowSize;
			}
			set {
				windowSize = value;
			}
		}
		
		uint clearAverage;
		
		public uint ClearAverage {
			get {
				return clearAverage;
			}
			set {
				clearAverage = value;
			}
		}
		
		uint warnAverage;
		
		public uint WarnAverage {
			get {
				return warnAverage;
			}
			set {
				warnAverage = value;
			}
		}
		
		uint limitedAverage;
		
		public uint LimitedAverage {
			get {
				return limitedAverage;
			}
			set {
				limitedAverage = value;
			}
		}
		
		uint disconnectAverage;
		
		public uint DisconnectAverage {
			get {
				return disconnectAverage;
			}
			set {
				disconnectAverage = value;
			}
		}
		
		uint currentAverage;
		
		public uint CurrentAverage {
			get {
				return currentAverage;
			}
			set {
				currentAverage = value;
			}
		}
		
		uint maximalAverage;
		
		public uint MaximalAverage {
			get {
				return maximalAverage;
			}
			set {
				maximalAverage = value;
			}
		}
	}
	#endregion
	
	#region FamilyType
	public sealed class FamilyType : IByteConvertible
	{
		/// <summary>The FamilyType has always this size in bytes.</summary>
		public const int FixedSize = 2 + 2;
		
		/// <summary>Creates a new FamilyType.</summary>
		public FamilyType(ushort family, ushort type)
		{
			this.Family = family;
			this.Type = type;
		}
		
		/// <summary>Loads the FamilyType from the byte array.</summary>
		public FamilyType(byte[] data, int index, int count)
		{
			int pos = index;
			this.family = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.type = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
		}
		
		/// <summary>Gets the size of this FamilyType in bytes.</summary>
		public int GetByteLength()
		{
			return FixedSize;
		}
		
		/// <summary>Writes the byte representation of the FamilyType into the specified stream.</summary>
		public void WriteBytes(Stream stream)
		{
			stream.Write(NetworkBitConverter.GetBytes(family), 0, 2);
			stream.Write(NetworkBitConverter.GetBytes(type), 0, 2);
		}
		
		ushort family;
		
		public ushort Family {
			get {
				return family;
			}
			set {
				family = value;
			}
		}
		
		ushort type;
		
		public ushort Type {
			get {
				return type;
			}
			set {
				type = value;
			}
		}
	}
	#endregion
	
	#region RateClassCommand
	public sealed class RateClassCommand : IByteConvertible
	{
		/// <summary>Creates a new RateClassCommand.</summary>
		public RateClassCommand(ushort rateClass, FamilyType[] commands)
		{
			this.RateClass = rateClass;
			this.Commands = commands;
		}
		
		/// <summary>Loads the RateClassCommand from the byte array.</summary>
		public RateClassCommand(byte[] data, int index, int count)
		{
			int pos = index;
			this.rateClass = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.commands = new FamilyType[NetworkBitConverter.ToUInt16(data, pos)];
			pos += 2;
			for (int i = 0; i < this.commands.Length; ++i) {
				this.commands[i] = new FamilyType(data, pos, count + index - pos);
				pos += this.commands[i].GetByteLength();
			}
		}
		
		/// <summary>Gets the size of this RateClassCommand in bytes.</summary>
		public int GetByteLength()
		{
			return 2 + 2 + commands.Length * FamilyType.FixedSize;
		}
		
		/// <summary>Writes the byte representation of the RateClassCommand into the specified stream.</summary>
		public void WriteBytes(Stream stream)
		{
			stream.Write(NetworkBitConverter.GetBytes(rateClass), 0, 2);
			stream.Write(NetworkBitConverter.GetBytes((ushort)commands.Length), 0, 2);
			foreach (FamilyType a in commands) {
				a.WriteBytes(stream);
			}
		}
		
		ushort rateClass;
		
		public ushort RateClass {
			get {
				return rateClass;
			}
			set {
				rateClass = value;
			}
		}
		
		FamilyType[] commands;
		
		public FamilyType[] Commands {
			get {
				return commands;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("commands");
				commands = value;
			}
		}
	}
	#endregion
	
	#region RateInfoSnac
	public sealed class RateInfoSnac : Snac
	{
		/// <summary>The family id normally used for the RateInfoSnac.</summary>
		public static ushort SnacFamily = 0x0001;
		/// <summary>The SNAC subtype normally used for the RateInfoSnac.</summary>
		public static ushort SnacType = 0x0007;
		
		/// <summary>Creates a new RateInfoSnac.</summary>
		public RateInfoSnac(RateClassInfo[] infoBlocks, RateClassCommand[] commandsBlocks) : base(SnacFamily, SnacType)
		{
			this.InfoBlocks = infoBlocks;
			this.CommandsBlocks = commandsBlocks;
		}
		
		/// <summary>Loads the RateInfoSnac from the byte array.</summary>
		public RateInfoSnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.infoBlocks = new RateClassInfo[NetworkBitConverter.ToUInt16(data, pos)];
			pos += 2;
			for (int i = 0; i < this.infoBlocks.Length; ++i) {
				this.infoBlocks[i] = new RateClassInfo(data, pos, count + index - pos);
				pos += this.infoBlocks[i].GetByteLength();
			}
			ArrayList _arr = new ArrayList();
			while (pos < index + count) {
				_arr.Add(new RateClassCommand(data, pos, count + index - pos));
				pos += ((RateClassCommand)_arr[_arr.Count - 1]).GetByteLength();
			}
			this.commandsBlocks = (RateClassCommand[])_arr.ToArray(typeof(RateClassCommand));
		}
		
		/// <summary>Gets the size of this RateInfoSnac in bytes.</summary>
		public override int GetByteLength()
		{
			int size = base.GetByteLength() + 2 + infoBlocks.Length * RateClassInfo.FixedSize + 0;
			foreach (RateClassCommand a in commandsBlocks) {
				size += a.GetByteLength();
			}
			return size;
		}
		
		/// <summary>Writes the byte representation of the RateInfoSnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			stream.Write(NetworkBitConverter.GetBytes((ushort)infoBlocks.Length), 0, 2);
			foreach (RateClassInfo a in infoBlocks) {
				a.WriteBytes(stream);
			}
			foreach (RateClassCommand a in commandsBlocks) {
				a.WriteBytes(stream);
			}
		}
		
		RateClassInfo[] infoBlocks;
		
		public RateClassInfo[] InfoBlocks {
			get {
				return infoBlocks;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("infoBlocks");
				infoBlocks = value;
			}
		}
		
		RateClassCommand[] commandsBlocks;
		
		public RateClassCommand[] CommandsBlocks {
			get {
				return commandsBlocks;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("commandsBlocks");
				commandsBlocks = value;
			}
		}
	}
	#endregion
	
	#region RateAckSnac
	public sealed class RateAckSnac : Snac
	{
		/// <summary>The family id normally used for the RateAckSnac.</summary>
		public static ushort SnacFamily = 0x0001;
		/// <summary>The SNAC subtype normally used for the RateAckSnac.</summary>
		public static ushort SnacType = 0x0008;
		
		/// <summary>Creates a new RateAckSnac.</summary>
		public RateAckSnac(ushort[] classes) : base(SnacFamily, SnacType)
		{
			this.Classes = classes;
		}
		
		/// <summary>Loads the RateAckSnac from the byte array.</summary>
		public RateAckSnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.classes = new ushort[(count + index - pos) / 2];
			for (int i = 0; i < this.classes.Length; ++i) {
				this.classes[i] = NetworkBitConverter.ToUInt16(data, pos);
				pos += 2;
			}
		}
		
		/// <summary>Gets the size of this RateAckSnac in bytes.</summary>
		public override int GetByteLength()
		{
			return base.GetByteLength() + 0 + classes.Length * 2;
		}
		
		/// <summary>Writes the byte representation of the RateAckSnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			foreach (ushort a in classes) {
				stream.Write(NetworkBitConverter.GetBytes(a), 0, 2);
			}
		}
		
		ushort[] classes;
		
		public ushort[] Classes {
			get {
				return classes;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("classes");
				classes = value;
			}
		}
	}
	#endregion
	
	#region IcbmRequestParameterInfoSnac
	public sealed class IcbmRequestParameterInfoSnac : Snac
	{
		/// <summary>The family id normally used for the IcbmRequestParameterInfoSnac.</summary>
		public static ushort SnacFamily = 0x0004;
		/// <summary>The SNAC subtype normally used for the IcbmRequestParameterInfoSnac.</summary>
		public static ushort SnacType = 0x0004;
		
		/// <summary>Creates a new IcbmRequestParameterInfoSnac.</summary>
		public IcbmRequestParameterInfoSnac() : base(SnacFamily, SnacType)
		{
		}
		
		/// <summary>Loads the IcbmRequestParameterInfoSnac from the byte array.</summary>
		public IcbmRequestParameterInfoSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
	}
	#endregion
	
	#region IcbmParameterInfo
	public sealed class IcbmParameterInfo : IByteConvertible
	{
		/// <summary>The IcbmParameterInfo has always this size in bytes.</summary>
		public const int FixedSize = 2 + 4 + 2 + 2 + 2 + 4;
		
		/// <summary>Creates a new IcbmParameterInfo.</summary>
		public IcbmParameterInfo()
		{
			this.MaxChannel = 0;
			this.Flags = 3;
			this.MaxMessageLength = 8000;
			this.MaxSenderWarning = 999;
			this.MaxReceiverWarning = 999;
			this.MinMessageInterval = 0;
		}
		
		/// <summary>Loads the IcbmParameterInfo from the byte array.</summary>
		public IcbmParameterInfo(byte[] data, int index, int count)
		{
			int pos = index;
			this.maxChannel = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.flags = NetworkBitConverter.ToUInt32(data, pos);
			pos += 4;
			this.maxMessageLength = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.maxSenderWarning = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.maxReceiverWarning = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.minMessageInterval = NetworkBitConverter.ToUInt32(data, pos);
			pos += 4;
		}
		
		/// <summary>Gets the size of this IcbmParameterInfo in bytes.</summary>
		public int GetByteLength()
		{
			return FixedSize;
		}
		
		/// <summary>Writes the byte representation of the IcbmParameterInfo into the specified stream.</summary>
		public void WriteBytes(Stream stream)
		{
			stream.Write(NetworkBitConverter.GetBytes(maxChannel), 0, 2);
			stream.Write(NetworkBitConverter.GetBytes(flags), 0, 4);
			stream.Write(NetworkBitConverter.GetBytes(maxMessageLength), 0, 2);
			stream.Write(NetworkBitConverter.GetBytes(maxSenderWarning), 0, 2);
			stream.Write(NetworkBitConverter.GetBytes(maxReceiverWarning), 0, 2);
			stream.Write(NetworkBitConverter.GetBytes(minMessageInterval), 0, 4);
		}
		
		ushort maxChannel;
		
		public ushort MaxChannel {
			get {
				return maxChannel;
			}
			set {
				maxChannel = value;
			}
		}
		
		uint flags;
		
		public uint Flags {
			get {
				return flags;
			}
			set {
				flags = value;
			}
		}
		
		ushort maxMessageLength;
		
		public ushort MaxMessageLength {
			get {
				return maxMessageLength;
			}
			set {
				maxMessageLength = value;
			}
		}
		
		ushort maxSenderWarning;
		
		public ushort MaxSenderWarning {
			get {
				return maxSenderWarning;
			}
			set {
				maxSenderWarning = value;
			}
		}
		
		ushort maxReceiverWarning;
		
		public ushort MaxReceiverWarning {
			get {
				return maxReceiverWarning;
			}
			set {
				maxReceiverWarning = value;
			}
		}
		
		uint minMessageInterval;
		
		public uint MinMessageInterval {
			get {
				return minMessageInterval;
			}
			set {
				minMessageInterval = value;
			}
		}
	}
	#endregion
	
	#region IcbmParameterInfoSnac
	public sealed class IcbmParameterInfoSnac : Snac
	{
		/// <summary>The family id normally used for the IcbmParameterInfoSnac.</summary>
		public static ushort SnacFamily = 0x0004;
		/// <summary>The SNAC subtype normally used for the IcbmParameterInfoSnac.</summary>
		public static ushort SnacType = 0x0005;
		
		/// <summary>Creates a new IcbmParameterInfoSnac.</summary>
		public IcbmParameterInfoSnac(IcbmParameterInfo parameterInfo) : base(SnacFamily, SnacType)
		{
			this.ParameterInfo = parameterInfo;
		}
		
		/// <summary>Loads the IcbmParameterInfoSnac from the byte array.</summary>
		public IcbmParameterInfoSnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.parameterInfo = new IcbmParameterInfo(data, pos, count + index - pos);
			pos += this.parameterInfo.GetByteLength();
		}
		
		/// <summary>Gets the size of this IcbmParameterInfoSnac in bytes.</summary>
		public override int GetByteLength()
		{
			return base.GetByteLength() + IcbmParameterInfo.FixedSize;
		}
		
		/// <summary>Writes the byte representation of the IcbmParameterInfoSnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			parameterInfo.WriteBytes(stream);
		}
		
		IcbmParameterInfo parameterInfo;
		
		public IcbmParameterInfo ParameterInfo {
			get {
				return parameterInfo;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("parameterInfo");
				parameterInfo = value;
			}
		}
	}
	#endregion
	
	#region IcbmSetParameterInfoSnac
	public sealed class IcbmSetParameterInfoSnac : Snac
	{
		/// <summary>The family id normally used for the IcbmSetParameterInfoSnac.</summary>
		public static ushort SnacFamily = 0x0004;
		/// <summary>The SNAC subtype normally used for the IcbmSetParameterInfoSnac.</summary>
		public static ushort SnacType = 0x0002;
		
		/// <summary>Creates a new IcbmSetParameterInfoSnac.</summary>
		public IcbmSetParameterInfoSnac(IcbmParameterInfo parameterInfo) : base(SnacFamily, SnacType)
		{
			this.ParameterInfo = parameterInfo;
		}
		
		/// <summary>Loads the IcbmSetParameterInfoSnac from the byte array.</summary>
		public IcbmSetParameterInfoSnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.parameterInfo = new IcbmParameterInfo(data, pos, count + index - pos);
			pos += this.parameterInfo.GetByteLength();
		}
		
		/// <summary>Gets the size of this IcbmSetParameterInfoSnac in bytes.</summary>
		public override int GetByteLength()
		{
			return base.GetByteLength() + IcbmParameterInfo.FixedSize;
		}
		
		/// <summary>Writes the byte representation of the IcbmSetParameterInfoSnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			parameterInfo.WriteBytes(stream);
		}
		
		IcbmParameterInfo parameterInfo;
		
		public IcbmParameterInfo ParameterInfo {
			get {
				return parameterInfo;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("parameterInfo");
				parameterInfo = value;
			}
		}
	}
	#endregion
	
	#region LocationRightsRequestSnac
	public sealed class LocationRightsRequestSnac : Snac
	{
		/// <summary>The family id normally used for the LocationRightsRequestSnac.</summary>
		public static ushort SnacFamily = 0x0002;
		/// <summary>The SNAC subtype normally used for the LocationRightsRequestSnac.</summary>
		public static ushort SnacType = 0x0002;
		
		/// <summary>Creates a new LocationRightsRequestSnac.</summary>
		public LocationRightsRequestSnac() : base(SnacFamily, SnacType)
		{
		}
		
		/// <summary>Loads the LocationRightsRequestSnac from the byte array.</summary>
		public LocationRightsRequestSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
	}
	#endregion
	
	#region LocationRightsSnac
	public sealed class LocationRightsSnac : TlvBasedSnac
	{
		/// <summary>The family id normally used for the LocationRightsSnac.</summary>
		public static ushort SnacFamily = 0x0002;
		/// <summary>The SNAC subtype normally used for the LocationRightsSnac.</summary>
		public static ushort SnacType = 0x0003;
		
		/// <summary>Creates a new LocationRightsSnac.</summary>
		public LocationRightsSnac(ushort maxInfoLength) : base(SnacFamily, SnacType)
		{
			this.MaxInfoLength = maxInfoLength;
		}
		
		/// <summary>Loads the LocationRightsSnac from the byte array.</summary>
		public LocationRightsSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
		
		public ushort MaxInfoLength {
			get {
				return Chain.GetShort(0x0001);
			}
			set {
				Chain.SetShort(0x0001, value);
			}
		}
	}
	#endregion
	
	#region SsiRightsRequestSnac
	public sealed class SsiRightsRequestSnac : Snac
	{
		/// <summary>The family id normally used for the SsiRightsRequestSnac.</summary>
		public static ushort SnacFamily = 0x0013;
		/// <summary>The SNAC subtype normally used for the SsiRightsRequestSnac.</summary>
		public static ushort SnacType = 0x0002;
		
		/// <summary>Creates a new SsiRightsRequestSnac.</summary>
		public SsiRightsRequestSnac() : base(SnacFamily, SnacType)
		{
		}
		
		/// <summary>Loads the SsiRightsRequestSnac from the byte array.</summary>
		public SsiRightsRequestSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
	}
	#endregion
	
	#region SsiRightsSnac
	public sealed class SsiRightsSnac : TlvBasedSnac
	{
		/// <summary>The family id normally used for the SsiRightsSnac.</summary>
		public static ushort SnacFamily = 0x0013;
		/// <summary>The SNAC subtype normally used for the SsiRightsSnac.</summary>
		public static ushort SnacType = 0x0003;
		
		/// <summary>Creates a new SsiRightsSnac.</summary>
		public SsiRightsSnac(byte[] data) : base(SnacFamily, SnacType)
		{
			this.Data = data;
		}
		
		/// <summary>Loads the SsiRightsSnac from the byte array.</summary>
		public SsiRightsSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
		
		public byte[] Data {
			get {
				return Chain.GetData(0x0004);
			}
			set {
				if (value == null)
					throw new ArgumentNullException("data");
				Chain.SetData(0x0004, value);
			}
		}
	}
	#endregion
	
	#region SsiDataRequestSnac
	public sealed class SsiDataRequestSnac : Snac
	{
		/// <summary>The family id normally used for the SsiDataRequestSnac.</summary>
		public static ushort SnacFamily = 0x0013;
		/// <summary>The SNAC subtype normally used for the SsiDataRequestSnac.</summary>
		public static ushort SnacType = 0x0004;
		
		/// <summary>Creates a new SsiDataRequestSnac.</summary>
		public SsiDataRequestSnac() : base(SnacFamily, SnacType)
		{
		}
		
		/// <summary>Loads the SsiDataRequestSnac from the byte array.</summary>
		public SsiDataRequestSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
	}
	#endregion
	
	#region SsiDataSnac
	public sealed class SsiDataSnac : Snac
	{
		/// <summary>The family id normally used for the SsiDataSnac.</summary>
		public static ushort SnacFamily = 0x0013;
		/// <summary>The SNAC subtype normally used for the SsiDataSnac.</summary>
		public static ushort SnacType = 0x0006;
		
		/// <summary>Creates a new SsiDataSnac.</summary>
		public SsiDataSnac(SsiItem[] items, DateTime lastModification) : base(SnacFamily, SnacType)
		{
			this.Version = 0;
			this.Items = items;
			this.LastModification = lastModification;
		}
		
		/// <summary>Loads the SsiDataSnac from the byte array.</summary>
		public SsiDataSnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.version = data[pos++];
			this.items = new SsiItem[NetworkBitConverter.ToUInt16(data, pos)];
			pos += 2;
			for (int i = 0; i < this.items.Length; ++i) {
				this.items[i] = new SsiItem(data, pos, count + index - pos);
				pos += this.items[i].GetByteLength();
			}
			this.lastModification = new DateTime(1970, 1, 1).AddSeconds(NetworkBitConverter.ToUInt32(data, pos)).ToLocalTime();
			pos += 4;
		}
		
		/// <summary>Gets the size of this SsiDataSnac in bytes.</summary>
		public override int GetByteLength()
		{
			int size = base.GetByteLength() + 1 + 2 + 4;
			foreach (SsiItem a in items) {
				size += a.GetByteLength();
			}
			return size;
		}
		
		/// <summary>Writes the byte representation of the SsiDataSnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			stream.WriteByte(version);
			stream.Write(NetworkBitConverter.GetBytes((ushort)items.Length), 0, 2);
			foreach (SsiItem a in items) {
				a.WriteBytes(stream);
			}
			stream.Write(NetworkBitConverter.GetBytes((int)lastModification.ToUniversalTime().Subtract(new DateTime(1970, 1, 1)).TotalSeconds), 0, 4);
		}
		
		byte version;
		
		public byte Version {
			get {
				return version;
			}
			set {
				version = value;
			}
		}
		
		SsiItem[] items;
		
		public SsiItem[] Items {
			get {
				return items;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("items");
				items = value;
			}
		}
		
		DateTime lastModification;
		
		public DateTime LastModification {
			get {
				return lastModification;
			}
			set {
				lastModification = value;
			}
		}
	}
	#endregion
	
	#region ActivateSsiSnac
	public sealed class ActivateSsiSnac : Snac
	{
		/// <summary>The family id normally used for the ActivateSsiSnac.</summary>
		public static ushort SnacFamily = 0x0013;
		/// <summary>The SNAC subtype normally used for the ActivateSsiSnac.</summary>
		public static ushort SnacType = 0x0007;
		
		/// <summary>Creates a new ActivateSsiSnac.</summary>
		public ActivateSsiSnac() : base(SnacFamily, SnacType)
		{
		}
		
		/// <summary>Loads the ActivateSsiSnac from the byte array.</summary>
		public ActivateSsiSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
	}
	#endregion
	
	#region MyInfoRequestSnac
	public sealed class MyInfoRequestSnac : Snac
	{
		/// <summary>The family id normally used for the MyInfoRequestSnac.</summary>
		public static ushort SnacFamily = 0x0001;
		/// <summary>The SNAC subtype normally used for the MyInfoRequestSnac.</summary>
		public static ushort SnacType = 0x000e;
		
		/// <summary>Creates a new MyInfoRequestSnac.</summary>
		public MyInfoRequestSnac() : base(SnacFamily, SnacType)
		{
		}
		
		/// <summary>Loads the MyInfoRequestSnac from the byte array.</summary>
		public MyInfoRequestSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
	}
	#endregion
	
	#region FamilyToolVersion
	public sealed class FamilyToolVersion : IByteConvertible
	{
		/// <summary>The FamilyToolVersion has always this size in bytes.</summary>
		public const int FixedSize = 2 + 2 + 2 + 2;
		
		/// <summary>Creates a new FamilyToolVersion.</summary>
		public FamilyToolVersion(ushort family, ushort version, ushort toolID, ushort toolVersion)
		{
			this.Family = family;
			this.Version = version;
			this.ToolID = toolID;
			this.ToolVersion = toolVersion;
		}
		
		/// <summary>Loads the FamilyToolVersion from the byte array.</summary>
		public FamilyToolVersion(byte[] data, int index, int count)
		{
			int pos = index;
			this.family = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.version = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.toolID = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.toolVersion = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
		}
		
		/// <summary>Gets the size of this FamilyToolVersion in bytes.</summary>
		public int GetByteLength()
		{
			return FixedSize;
		}
		
		/// <summary>Writes the byte representation of the FamilyToolVersion into the specified stream.</summary>
		public void WriteBytes(Stream stream)
		{
			stream.Write(NetworkBitConverter.GetBytes(family), 0, 2);
			stream.Write(NetworkBitConverter.GetBytes(version), 0, 2);
			stream.Write(NetworkBitConverter.GetBytes(toolID), 0, 2);
			stream.Write(NetworkBitConverter.GetBytes(toolVersion), 0, 2);
		}
		
		ushort family;
		
		public ushort Family {
			get {
				return family;
			}
			set {
				family = value;
			}
		}
		
		ushort version;
		
		public ushort Version {
			get {
				return version;
			}
			set {
				version = value;
			}
		}
		
		ushort toolID;
		
		public ushort ToolID {
			get {
				return toolID;
			}
			set {
				toolID = value;
			}
		}
		
		ushort toolVersion;
		
		public ushort ToolVersion {
			get {
				return toolVersion;
			}
			set {
				toolVersion = value;
			}
		}
	}
	#endregion
	
	#region ClientReadySnac
	public sealed class ClientReadySnac : Snac
	{
		/// <summary>The family id normally used for the ClientReadySnac.</summary>
		public static ushort SnacFamily = 0x0001;
		/// <summary>The SNAC subtype normally used for the ClientReadySnac.</summary>
		public static ushort SnacType = 0x0002;
		
		/// <summary>Creates a new ClientReadySnac.</summary>
		public ClientReadySnac(FamilyToolVersion[] tools) : base(SnacFamily, SnacType)
		{
			this.Tools = tools;
		}
		
		/// <summary>Loads the ClientReadySnac from the byte array.</summary>
		public ClientReadySnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.tools = new FamilyToolVersion[(count + index - pos) / FamilyToolVersion.FixedSize];
			for (int i = 0; i < this.tools.Length; ++i) {
				this.tools[i] = new FamilyToolVersion(data, pos, count + index - pos);
				pos += this.tools[i].GetByteLength();
			}
		}
		
		/// <summary>Gets the size of this ClientReadySnac in bytes.</summary>
		public override int GetByteLength()
		{
			return base.GetByteLength() + 0 + tools.Length * FamilyToolVersion.FixedSize;
		}
		
		/// <summary>Writes the byte representation of the ClientReadySnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			foreach (FamilyToolVersion a in tools) {
				a.WriteBytes(stream);
			}
		}
		
		FamilyToolVersion[] tools;
		
		public FamilyToolVersion[] Tools {
			get {
				return tools;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("tools");
				tools = value;
			}
		}
	}
	#endregion
	
	#region MessageFragment
	public sealed class MessageFragment : IByteConvertible
	{
		/// <summary>Creates a new MessageFragment.</summary>
		public MessageFragment(byte identifier, byte[] data)
		{
			this.Identifier = identifier;
			this.Version = 1;
			this.Data = data;
		}
		
		/// <summary>Loads the MessageFragment from the byte array.</summary>
		public MessageFragment(byte[] data, int index, int count)
		{
			int pos = index;
			this.identifier = data[pos++];
			this.version = data[pos++];
			this.data = new byte[NetworkBitConverter.ToUInt16(data, pos)];
			pos += 2;
			for (int i = 0; i < this.data.Length; ++i) {
				this.data[i] = data[pos++];
			}
		}
		
		/// <summary>Gets the size of this MessageFragment in bytes.</summary>
		public int GetByteLength()
		{
			return 1 + 1 + 2 + data.Length * 1;
		}
		
		/// <summary>Writes the byte representation of the MessageFragment into the specified stream.</summary>
		public void WriteBytes(Stream stream)
		{
			stream.WriteByte(identifier);
			stream.WriteByte(version);
			stream.Write(NetworkBitConverter.GetBytes((ushort)data.Length), 0, 2);
			foreach (byte a in data) {
				stream.WriteByte(a);
			}
		}
		
		byte identifier;
		
		public byte Identifier {
			get {
				return identifier;
			}
			set {
				identifier = value;
			}
		}
		
		byte version;
		
		public byte Version {
			get {
				return version;
			}
			set {
				version = value;
			}
		}
		
		byte[] data;
		
		public byte[] Data {
			get {
				return data;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("data");
				data = value;
			}
		}
	}
	#endregion
	
	#region OutgoingIcbmSnac
	public sealed class OutgoingIcbmSnac : Snac
	{
		/// <summary>The family id normally used for the OutgoingIcbmSnac.</summary>
		public static ushort SnacFamily = 0x0004;
		/// <summary>The SNAC subtype normally used for the OutgoingIcbmSnac.</summary>
		public static ushort SnacType = 0x0006;
		
		/// <summary>Creates a new OutgoingIcbmSnac.</summary>
		/// <param name="dataChain">The TlvChain containing the message data.</param>
		public OutgoingIcbmSnac(ushort channel, string screenname, TlvChain dataChain) : base(SnacFamily, SnacType)
		{
			this.IcbmID = new byte[8];
			this.Channel = channel;
			this.Screenname = screenname;
			this.DataChain = dataChain;
		}
		
		/// <summary>Loads the OutgoingIcbmSnac from the byte array.</summary>
		public OutgoingIcbmSnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.icbmID = new byte[8];
			for (int i = 0; i < this.icbmID.Length; ++i) {
				this.icbmID[i] = data[pos++];
			}
			this.channel = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.screenname = Tlv.Encoding.GetString(data, pos + 1, data[pos]);
			pos += 1 + data[pos];
			this.dataChain = new TlvChain(data, pos, count + index - pos);
			pos += this.dataChain.GetByteLength();
		}
		
		/// <summary>Gets the size of this OutgoingIcbmSnac in bytes.</summary>
		public override int GetByteLength()
		{
			return base.GetByteLength() + 8 * 1 + 2 + 1 + Tlv.Encoding.GetByteCount(screenname) + dataChain.GetByteLength();
		}
		
		/// <summary>Writes the byte representation of the OutgoingIcbmSnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			foreach (byte a in icbmID) {
				stream.WriteByte(a);
			}
			stream.Write(NetworkBitConverter.GetBytes(channel), 0, 2);
			byte[] _text = Tlv.Encoding.GetBytes(screenname);
			stream.WriteByte((byte)_text.Length);
			stream.Write(_text, 0, _text.Length);
			dataChain.WriteBytes(stream);
		}
		
		byte[] icbmID;
		
		public byte[] IcbmID {
			get {
				return icbmID;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("icbmID");
				if (value.Length != 8)
					throw new ArgumentException("The array IcbmID must have exactly 8 elements.", "icbmID");
				icbmID = value;
			}
		}
		
		ushort channel;
		
		public ushort Channel {
			get {
				return channel;
			}
			set {
				channel = value;
			}
		}
		
		string screenname;
		
		public string Screenname {
			get {
				return screenname;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("screenname");
				screenname = value;
			}
		}
		
		TlvChain dataChain;
		
		/// <summary>The TlvChain containing the message data.</summary>
		public TlvChain DataChain {
			get {
				return dataChain;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("dataChain");
				dataChain = value;
			}
		}
	}
	#endregion
	
	#region IncomingIcbmSnac
	public sealed class IncomingIcbmSnac : Snac
	{
		/// <summary>The family id normally used for the IncomingIcbmSnac.</summary>
		public static ushort SnacFamily = 0x0004;
		/// <summary>The SNAC subtype normally used for the IncomingIcbmSnac.</summary>
		public static ushort SnacType = 0x0007;
		
		/// <summary>Creates a new IncomingIcbmSnac.</summary>
		/// <param name="dataChain">The TlvChain containing the message data.</param>
		public IncomingIcbmSnac(ushort channel, UserInfo userInfo, TlvChain dataChain) : base(SnacFamily, SnacType)
		{
			this.IcbmID = new byte[8];
			this.Channel = channel;
			this.UserInfo = userInfo;
			this.DataChain = dataChain;
		}
		
		/// <summary>Loads the IncomingIcbmSnac from the byte array.</summary>
		public IncomingIcbmSnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.icbmID = new byte[8];
			for (int i = 0; i < this.icbmID.Length; ++i) {
				this.icbmID[i] = data[pos++];
			}
			this.channel = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.userInfo = new UserInfo(data, pos, count + index - pos);
			pos += this.userInfo.GetByteLength();
			this.dataChain = new TlvChain(data, pos, count + index - pos);
			pos += this.dataChain.GetByteLength();
		}
		
		/// <summary>Gets the size of this IncomingIcbmSnac in bytes.</summary>
		public override int GetByteLength()
		{
			return base.GetByteLength() + 8 * 1 + 2 + userInfo.GetByteLength() + dataChain.GetByteLength();
		}
		
		/// <summary>Writes the byte representation of the IncomingIcbmSnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			foreach (byte a in icbmID) {
				stream.WriteByte(a);
			}
			stream.Write(NetworkBitConverter.GetBytes(channel), 0, 2);
			userInfo.WriteBytes(stream);
			dataChain.WriteBytes(stream);
		}
		
		byte[] icbmID;
		
		public byte[] IcbmID {
			get {
				return icbmID;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("icbmID");
				if (value.Length != 8)
					throw new ArgumentException("The array IcbmID must have exactly 8 elements.", "icbmID");
				icbmID = value;
			}
		}
		
		ushort channel;
		
		public ushort Channel {
			get {
				return channel;
			}
			set {
				channel = value;
			}
		}
		
		UserInfo userInfo;
		
		public UserInfo UserInfo {
			get {
				return userInfo;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("userInfo");
				userInfo = value;
			}
		}
		
		TlvChain dataChain;
		
		/// <summary>The TlvChain containing the message data.</summary>
		public TlvChain DataChain {
			get {
				return dataChain;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("dataChain");
				dataChain = value;
			}
		}
	}
	#endregion
	
	#region ImAckSnac
	public sealed class ImAckSnac : Snac
	{
		/// <summary>The family id normally used for the ImAckSnac.</summary>
		public static ushort SnacFamily = 0x0004;
		/// <summary>The SNAC subtype normally used for the ImAckSnac.</summary>
		public static ushort SnacType = 0x000c;
		
		/// <summary>Creates a new ImAckSnac.</summary>
		public ImAckSnac() : base(SnacFamily, SnacType)
		{
		}
		
		/// <summary>Loads the ImAckSnac from the byte array.</summary>
		public ImAckSnac(byte[] data, int index, int count) : base(data, index, count)
		{
		}
	}
	#endregion
	
	#region SendTypingStateSnac
	public sealed class SendTypingStateSnac : Snac
	{
		/// <summary>The family id normally used for the SendTypingStateSnac.</summary>
		public static ushort SnacFamily = 0x0004;
		/// <summary>The SNAC subtype normally used for the SendTypingStateSnac.</summary>
		public static ushort SnacType = 0x0014;
		
		/// <summary>Creates a new SendTypingStateSnac.</summary>
		public SendTypingStateSnac(string screenname, ushort state) : base(SnacFamily, SnacType)
		{
			this.Nulls = new byte[8];
			this.Code = 1;
			this.Screenname = screenname;
			this.State = state;
		}
		
		/// <summary>Loads the SendTypingStateSnac from the byte array.</summary>
		public SendTypingStateSnac(byte[] data, int index, int count) : base(data, index, count)
		{
			int pos = index + base.GetByteLength();
			this.nulls = new byte[8];
			for (int i = 0; i < this.nulls.Length; ++i) {
				this.nulls[i] = data[pos++];
			}
			this.code = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.screenname = Tlv.Encoding.GetString(data, pos + 1, data[pos]);
			pos += 1 + data[pos];
			this.state = NetworkBitConverter.ToUInt16(data, pos);
			pos += 2;
		}
		
		/// <summary>Gets the size of this SendTypingStateSnac in bytes.</summary>
		public override int GetByteLength()
		{
			return base.GetByteLength() + 8 * 1 + 2 + 1 + Tlv.Encoding.GetByteCount(screenname) + 2;
		}
		
		/// <summary>Writes the byte representation of the SendTypingStateSnac into the specified stream.</summary>
		public override void WriteBytes(Stream stream)
		{
			base.WriteBytes(stream);
			foreach (byte a in nulls) {
				stream.WriteByte(a);
			}
			stream.Write(NetworkBitConverter.GetBytes(code), 0, 2);
			byte[] _text = Tlv.Encoding.GetBytes(screenname);
			stream.WriteByte((byte)_text.Length);
			stream.Write(_text, 0, _text.Length);
			stream.Write(NetworkBitConverter.GetBytes(state), 0, 2);
		}
		
		byte[] nulls;
		
		public byte[] Nulls {
			get {
				return nulls;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("nulls");
				if (value.Length != 8)
					throw new ArgumentException("The array Nulls must have exactly 8 elements.", "nulls");
				nulls = value;
			}
		}
		
		ushort code;
		
		public ushort Code {
			get {
				return code;
			}
			set {
				code = value;
			}
		}
		
		string screenname;
		
		public string Screenname {
			get {
				return screenname;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("screenname");
				screenname = value;
			}
		}
		
		ushort state;
		
		public ushort State {
			get {
				return state;
			}
			set {
				state = value;
			}
		}
	}
	#endregion
	
	#region IcqMetaInfoSearchResult
	public sealed class IcqMetaInfoSearchResult : IByteConvertible
	{
		/// <summary>Creates a new IcqMetaInfoSearchResult.</summary>
		public IcqMetaInfoSearchResult(uint uin, string nickname, string firstName, string lastName, string eMail, byte authorization, ushort onlineStatus, byte gender, ushort age)
		{
			this.Uin = uin;
			this.Nickname = nickname;
			this.FirstName = firstName;
			this.LastName = lastName;
			this.EMail = eMail;
			this.Authorization = authorization;
			this.OnlineStatus = onlineStatus;
			this.Gender = gender;
			this.Age = age;
		}
		
		/// <summary>Loads the IcqMetaInfoSearchResult from the byte array.</summary>
		public IcqMetaInfoSearchResult(byte[] data, int index, int count)
		{
			int pos = index;
			this.uin = LEBitConverter.ToUInt32(data, pos);
			pos += 4;
			this.nickname = MirabilisTlv.ReadString(data, ref pos);
			this.firstName = MirabilisTlv.ReadString(data, ref pos);
			this.lastName = MirabilisTlv.ReadString(data, ref pos);
			this.eMail = MirabilisTlv.ReadString(data, ref pos);
			this.authorization = data[pos++];
			this.onlineStatus = LEBitConverter.ToUInt16(data, pos);
			pos += 2;
			this.gender = data[pos++];
			this.age = LEBitConverter.ToUInt16(data, pos);
			pos += 2;
		}
		
		/// <summary>Gets the size of this IcqMetaInfoSearchResult in bytes.</summary>
		public int GetByteLength()
		{
			return 4 + 3 + Tlv.Encoding.GetByteCount(nickname) + 3 + Tlv.Encoding.GetByteCount(firstName) + 3 + Tlv.Encoding.GetByteCount(lastName) + 3 + Tlv.Encoding.GetByteCount(eMail) + 1 + 2 + 1 + 2;
		}
		
		/// <summary>Writes the byte representation of the IcqMetaInfoSearchResult into the specified stream.</summary>
		public void WriteBytes(Stream stream)
		{
			stream.Write(LEBitConverter.GetBytes(uin), 0, 4);
			byte[] _text = MirabilisTlv.EncodeString(nickname);
			stream.Write(_text, 0, _text.Length);
			_text = MirabilisTlv.EncodeString(firstName);
			stream.Write(_text, 0, _text.Length);
			_text = MirabilisTlv.EncodeString(lastName);
			stream.Write(_text, 0, _text.Length);
			_text = MirabilisTlv.EncodeString(eMail);
			stream.Write(_text, 0, _text.Length);
			stream.WriteByte(authorization);
			stream.Write(LEBitConverter.GetBytes(onlineStatus), 0, 2);
			stream.WriteByte(gender);
			stream.Write(LEBitConverter.GetBytes(age), 0, 2);
		}
		
		uint uin;
		
		public uint Uin {
			get {
				return uin;
			}
			set {
				uin = value;
			}
		}
		
		string nickname;
		
		public string Nickname {
			get {
				return nickname;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("nickname");
				nickname = value;
			}
		}
		
		string firstName;
		
		public string FirstName {
			get {
				return firstName;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("firstName");
				firstName = value;
			}
		}
		
		string lastName;
		
		public string LastName {
			get {
				return lastName;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("lastName");
				lastName = value;
			}
		}
		
		string eMail;
		
		public string EMail {
			get {
				return eMail;
			}
			set {
				if (value == null)
					throw new ArgumentNullException("eMail");
				eMail = value;
			}
		}
		
		byte authorization;
		
		public byte Authorization {
			get {
				return authorization;
			}
			set {
				authorization = value;
			}
		}
		
		ushort onlineStatus;
		
		public ushort OnlineStatus {
			get {
				return onlineStatus;
			}
			set {
				onlineStatus = value;
			}
		}
		
		byte gender;
		
		public byte Gender {
			get {
				return gender;
			}
			set {
				gender = value;
			}
		}
		
		ushort age;
		
		public ushort Age {
			get {
				return age;
			}
			set {
				age = value;
			}
		}
	}
	#endregion
}
