// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.IO;

namespace Grunwald.NOscar
{
	/// <summary>
	/// Describes any object that can be converted into a series of bytes.
	/// </summary>
	public interface IByteConvertible
	{
		/// <summary>
		/// Gets the total length this object would need in the byte array.
		/// </summary>
		int GetByteLength();
		
		/// <summary>
		/// Writes the byte representation of this object into the specified stream.
		/// </summary>
		void WriteBytes(Stream stream);
	}
}
