// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Xml;
using DGNetwork.Services;
using DGNetwork.Contacts;
using ICSharpCode.Core.Properties;

namespace DGNetwork.AddIns.IRC
{
	/// <summary>
	/// A contact inside an IRC server.
	/// </summary>
	public class ChannelContact : FixedContact
	{
		public IrcServerContact ServerContact {
			get {
				return (IrcServerContact)this.Parent;
			}
		}
		
		public ChannelContact(string name) : base()
		{
			this.Name = name;
			Init();
		}
		
		public ChannelContact(ChannelContact channel) : base(channel)
		{
			Init();
		}
		
		private void Init()
		{
			this.Icon = "Icons.IrcOffline";
		}
		
		public override void DoubleClick()
		{
			if (!ServerContact.Connected)
				ServerContact.Connect();
			else
				ServerContact.OpenChannel(this.Name);
		}
	}
}
