// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Collections;
using DGNetwork.Chat;
using DGNetwork.Services;
using Meebey.SmartIrc4net;

namespace DGNetwork.AddIns.IRC
{
	public class IrcChannelUser : AbstractUser
	{
		ChannelUser user;
		IrcClient irc;
		
		public IrcChannelUser(IrcClient irc, ChannelUser user)
		{
			this.user = user;
			this.irc = irc;
			this.Name = user.Nick;
			this.Icon = user.IsAway ? "Icons.IrcAway" : "Icons.IrcOnline";
		}
		
		public ChannelUser ChannelUser {
			get {
				return user;
			}
		}
		
		public override IMessageSendResult SendMessage(Message message)
		{
			return IrcService.SendMessage(irc, user.Nick, message);
		}
	}
}
