// <file>
//     <copyright see="prj:///doc/copyright.txt"/>
//     <license see="prj:///doc/license.txt"/>
//     <owner name="Mike Krüger" email="mike@icsharpcode.net"/>
//     <version value="$version"/>
// </file>

using System;
using System.Collections;
using System.CodeDom.Compiler;
using System.Windows.Forms;

using ICSharpCode.Core.Properties;

namespace DGNetwork.AddIns.Codons
{
	public abstract class AbstractCheckableMenuCommand : AbstractMenuCommand, ICheckableMenuCommand
	{
		bool isChecked = false;
		
		public bool IsChecked {
			get {
				return isChecked;
			}
			set {
				if (isChecked != value) {
					isChecked = value;
					if (IsCheckedChanged != null)
						IsCheckedChanged(this, EventArgs.Empty);
				}
			}
		}
		
		public event EventHandler IsCheckedChanged;
	}
}
