// <file>
//     <copyright see="prj:///doc/copyright.txt"/>
//     <license see="prj:///doc/license.txt"/>
//     <owner name="Mike Krüger" email="mike@icsharpcode.net"/>
//     <version value="$version"/>
// </file>

using System;
using ICSharpCode.Core.AddIns.Codons;

namespace DGNetwork.AddIns.Codons
{
	public interface IMenuCommand : ICommand
	{
		bool IsEnabled {
			get;
			set;
		}
		
		string MenuItemID {
			get;
			set;
		}
	}
	
	public abstract class AbstractMenuCommand : AbstractCommand, IMenuCommand
	{
		bool isEnabled = true;
		
		public virtual bool IsEnabled {
			get {
				return isEnabled;
			}
			set {
				isEnabled = value;
			}
		}
		
		string menuItemID;
		
		public string MenuItemID {
			get {
				return menuItemID;
			}
			set {
				menuItemID = value;
			}
		}
	}
}
