// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using ICSharpCode.Core.AddIns;
using ICSharpCode.Core.AddIns.Conditions;

namespace DGNetwork.AddIns
{
	[Condition]
	public class CommandLineCondition : AbstractCondition
	{
		[XmlMemberAttribute("commandline", IsRequired = true)]
		string commandline = null;
		
		public override bool IsValid(object caller)
		{
			return CommandLine.Instance.HasFlag(commandline);
		}
	}
}
