// <file>
//     <copyright see="prj:///doc/copyright.txt"/>
//     <license see="prj:///doc/license.txt"/>
//     <owner name="Daniel Grunwald" email="daniel@danielgrunwald.de"/>
// </file>

using System;
using System.Runtime.Serialization;

namespace DGNetwork
{
	/// <summary>
	/// Base exception for all custom exceptions thrown by the DG Network Base.
	/// </summary>
	[Serializable()]
	public class BaseException : ApplicationException
	{
		/// <summary>
		/// Creates a new BaseException.
		/// </summary>
		public BaseException()
			: base()
		{
		}
		
		/// <summary>
		/// Creates a new BaseException.
		/// </summary>
		public BaseException(string message)
			: base(message)
		{
		}
		
		/// <summary>
		/// Creates a new BaseException.
		/// </summary>
		public BaseException(string message, Exception innerException)
			: base(message, innerException)
		{
		}
		
		/// <summary>
		/// Creates a new BaseException.
		/// </summary>
		protected BaseException(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}
	}
}
