// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.IO;

namespace DGNetwork.Chat
{
	/// <summary>
	/// Interface for commands in the chat window.
	/// </summary>
	public interface IChatCommand
	{
		string Name { get; }
		
		string Help { get; }
		
		bool Run(string parameters, IChatRoom chatRoom, TextWriter output);
	}
	
	public abstract class AbstractChatCommand : IChatCommand
	{
		string name;
		
		public AbstractChatCommand(string name)
		{
			this.name = name;
		}
		
		public string Name {
			get {
				return name;
			}
		}
		
		string help;
		
		public string Help {
			get {
				return help;
			}
			set {
				help = value;
			}
		}
		
		public abstract bool Run(string parameters, IChatRoom chatRoom, TextWriter output);
	}
}
