// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Drawing;
using System.Windows.Forms;
using DGNetwork.Services;
using ICSharpCode.Core.Properties;
using ICSharpCode.Core.Services;

namespace DGNetwork.Chat
{
	public class ChatProperties
	{
		public static Color Color {
			get {
				return (Color)Service.Property.GetProperty("Chat.Color", Color.Black);
			}
			set {
				Service.Property.SetProperty("Chat.Color", value);
			}
		}
		
		public static Font Font {
			get {
				object obj = Service.Property.GetProperty("Chat.Font", typeof(Font));
				if (obj == null) {
					obj = new Font("Verdana", 9.75F, FontStyle.Regular);
					Service.Property.SetProperty("Chat.Font", obj);
				}
				return (Font)obj;
			}
			set {
				Service.Property.SetProperty("Chat.Font", value);
			}
		}
	}
}
