// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;

namespace DGNetwork.Chat
{
	public interface IEditBoxFactory
	{
		string Name { get; }
		string Title { get; }
		IEditBox Create();
	}
	
	public class DefaultEditBoxFactory : IEditBoxFactory
	{
		string name, title;
		Type editBoxType;
		
		public Type EditBoxType {
			get {
				return editBoxType;
			}
		}
		
		public string Name {
			get {
				return name;
			}
		}
		
		public string Title {
			get {
				return title;
			}
		}
		
		public DefaultEditBoxFactory(string name, string title, Type editBoxType)
		{
			this.editBoxType = editBoxType;
			this.name = name;
			this.title = title;
		}
		
		public IEditBox Create()
		{
			return (IEditBox)Activator.CreateInstance(editBoxType);
		}
	}
}
