// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;

namespace DGNetwork.Chat
{
	public interface IMessageFilter
	{
		/// <summary>
		/// Filters the message. The method can change the message's properties.
		/// </summary>
		/// <param name="message">
		/// The message being filtered.
		/// </param>
		/// <param name="mode">
		/// The mode parameter determines the message mode(s) that will be used further
		/// so e.g. the chat code to html filter can ignore messages if they are
		/// going to a text only network.
		/// </param>
		void Filter(Message message, MessageModes mode, object owner);
	}
}
