// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Text;

namespace DGNetwork.Chat.Parser.Display
{
	public class CodeTag : ContentTag
	{
		public override void WriteContentTag(StringBuilder b, TagInfo tag, string content, HtmlFilter filter)
		{
			if (content.IndexOf('\n') < 0) {
				// only a single line of code
				b.Append("<code>");
				b.Append(HtmlHelper.EncodeEntities(content));
				b.Append("</code>");
			} else {
				b.Append("<pre class=\"code\">");
				b.Append(HtmlHelper.EncodeEntities(content));
				b.Append("</pre>");
			}
		}
	}
}
