// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Collections.Specialized;
using System.Text;

namespace DGNetwork.Chat.Parser
{
	public class TagInfo
	{
		public TagInfo CreateEndTag()
		{
			TagInfo n = new TagInfo();
			n.name = this.name;
			n.isEndTag = true;
			n.startPos = this.startPos;
			n.endPos = this.endPos;
			n.startChar = this.startChar;
			n.endChar = this.endChar;
			return n;
		}
		
		string name;
		
		public string Name {
			get {
				return name;
			}
			set {
				name = value;
			}
		}
		
		bool isEndTag;
		
		public bool IsEndTag {
			get {
				return isEndTag;
			}
			set {
				isEndTag = value;
			}
		}
		
		int startPos, endPos;
		
		public int StartPos {
			get {
				return startPos;
			}
			set {
				startPos = value;
			}
		}
		
		public int EndPos {
			get {
				return endPos;
			}
			set {
				endPos = value;
			}
		}
		
		NameValueCollection attributes = new NameValueCollection();
		
		public NameValueCollection Attributes {
			get {
				return attributes;
			}
		}
		
		string directAttribute;
		
		/// <summary>
		/// The direct attribute is the attribute when there are no normal attributes
		/// [tagName=directAttribute]...[/tagName]
		/// </summary>
		public string DirectAttribute {
			get {
				return directAttribute;
			}
			set {
				directAttribute = value;
			}
		}
		
		char startChar, endChar;
		
		public char EndChar {
			get {
				return endChar;
			}
			set {
				endChar = value;
			}
		}
		
		public char StartChar {
			get {
				return startChar;
			}
			set {
				startChar = value;
			}
		}
	}
}
