// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Text;

namespace DGNetwork.Chat.Parser
{
	/// <summary>
	/// The type of a tag.
	/// </summary>
	public enum TagType
	{
		/// <summary>
		/// Invalid tag (e.g. tag rejected because of invalid parameters)
		/// </summary>
		Invalid,
		/// <summary>
		/// Simple tag: has no end tag (e.g. &lt;img src=&quot;URL&quot;&gt;)
		/// </summary>
		Simple,
		/// <summary>
		/// Block tag: has html as content (e.g. &lt;b&gt; ... &lt;/b&gt;)
		/// </summary>
		Block,
		/// <summary>
		/// Content tag: has plain text as content (e.g. &lt;pre&gt; .... &lt;/pre&gt;)
		/// </summary>
		Content
	}
}
