// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Collections;

namespace DGNetwork.Chat
{
	public class PrivateChatRoom : AbstractChatRoom
	{
		IUser user;
		ArrayList users = new ArrayList();
		
		public PrivateChatRoom(IUser user)
		{
			this.user = user;
			users.Add(user);
			users = ArrayList.ReadOnly(users);
			user.NameChanged += new EventHandler(UserNameChanged);
			UserNameChanged(null, null);
		}
		
		private void UserNameChanged(object sender, EventArgs e)
		{
			this.Title = "${res:Chat.PrivateWith}" + user.Name;
		}
		
		public override IMessageSendResult SendMessage(Message message)
		{
			return user.SendMessage(message);
		}
		
		public IUser User {
			get {
				return user;
			}
		}
		
		public override ArrayList Users {
			get {
				return users;
			}
		}
	}
}
