// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Drawing;
using System.Windows.Forms;
using DGNetwork.AddIns.Codons;
using DGNetwork.Services;
using ICSharpCode.Core.Properties;
using ICSharpCode.Core.Services;

namespace DGNetwork.Chat
{
	public class ChooseFontCommand : AbstractMenuCommand
	{
		public override void Run()
		{
			ChatPanel panel = (ChatPanel)this.Owner;
			using (FontDialog dlg = new FontDialog()) {
				dlg.Font = panel.EditBoxPanel.EditBox.Font;
				dlg.FontMustExist = true;
				dlg.AllowVerticalFonts = false;
				if (dlg.ShowDialog() == DialogResult.OK) {
					panel.EditBoxPanel.EditBox.Font = dlg.Font;
				}
			}
		}
	}
	
	public class ChooseColorCommand : AbstractMenuCommand
	{
		public override void Run()
		{
			ChatPanel panel = (ChatPanel)this.Owner;
			using (ColorDialog dlg = new ColorDialog()) {
				dlg.Color = panel.EditBoxPanel.EditBox.Color;
				dlg.CustomColors = (int[])Service.Property.GetProperty("Chat.CustomColors", dlg.CustomColors);
				if (dlg.ShowDialog() == DialogResult.OK) {
					Service.Property.SetProperty("Chat.CustomColors", dlg.CustomColors);
					panel.EditBoxPanel.EditBox.Color = dlg.Color;
				}
			}
		}
	}
}
