// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Windows.Forms;
using DGNetwork.Gui;

namespace DGNetwork.Commands.Xaml
{
	#region Close
	public class CloseOK : AbstractXamlCommand {
		public override void Handle(object sender, EventArgs e) {
			this.Form.DialogResult = DialogResult.OK;
			this.Form.Close();
		}
	}
	public class CloseYes : AbstractXamlCommand {
		public override void Handle(object sender, EventArgs e) {
			this.Form.DialogResult = DialogResult.Yes;
			this.Form.Close();
		}
	}
	public class CloseNo : AbstractXamlCommand {
		public override void Handle(object sender, EventArgs e) {
			this.Form.DialogResult = DialogResult.No;
			this.Form.Close();
		}
	}
	public class CloseCancel : AbstractXamlCommand {
		public override void Handle(object sender, EventArgs e) {
			this.Form.DialogResult = DialogResult.Cancel;
			this.Form.Close();
		}
	}
	public class ExitApplication : AbstractXamlCommand {
		public override void Handle(object sender, EventArgs e) {
			Application.Exit();
		}
	}
	#endregion
	
	public class ShowLicenseDialog : AbstractXamlCommand {
		public override void Handle(object sender, EventArgs e) {
			XmlForm.ShowForm("LicenseDialog");
		}
	}
}
