// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.IO;
using DGNetwork.Chat;

namespace DGNetwork.DGN.MUC
{
	public class AcceptInvitationCommand : AbstractChatCommand
	{
		public const string CommandName = "DGNMUCAcceptInvitation";
		
		public AcceptInvitationCommand() : base(CommandName)
		{
		}
		
		public override bool Run(string parameters, IChatRoom chatRoom, TextWriter output)
		{
			MUCService.AcceptInvitation(Convert.FromBase64String(parameters));
			return true;
		}
	}
}
