// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Collections;
using System.Text;
using DGNetwork.Chat;
using DGNetwork.Chat.Parser;
using DGNetwork.Services;

namespace DGNetwork.DGN.MUC
{
	public class InvitationTag : SimpleTag
	{
		public const string TagName = "DGNMUCAcceptInvitation";
		
		public InvitationTag()
		{
			this.Name = TagName;
		}
		
		public override void WriteTag(StringBuilder b, TagInfo tag, HtmlFilter filter)
		{
			b.Append("<input type=\"button\" value=");
			b.Append(HtmlHelper.EncodeAttribute(Service.Parse("${res:DGN.MUC.AcceptInvitationButton}")));
			b.Append(" onClick=");
			b.Append(HtmlHelper.EncodeAttribute("cmd('/" + AcceptInvitationCommand.CommandName + " " + Helper.EscapePart(GetAttribute(tag, "keyHash")) + "')"));
			b.Append(">");
		}
	}
}
