// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Collections;
using System.Windows.Forms;
using Grunwald.P2PLib.Network;
using Grunwald.P2PLib.DGNetwork;
using Grunwald.Gui.Controls;
using DGNetwork.Commands;
using DGNetwork.Gui.Dialogs;
using DGNetwork.Services;

namespace DGNetwork.DGN.Monitor
{
	public class HostEntryItem : DefaultMonitorItem, IExecutable
	{
		AddressCollection hostCache;
		AddressEntry e;
		NetworkMonitorItem parent;
		
		public HostEntryItem(AddressCollection hostCache, AddressEntry e, NetworkMonitorItem parent)
		{
			this.ContextMenuTreePath = "/Context/Monitor/HostEntry";
			this.hostCache = hostCache;
			this.e = e;
			this.parent = parent;
		}
		
		public bool CanExecute {
			get {
				return true;
			}
		}
		
		public void Execute(ExecuteContext executeContext)
		{
			hostCache.Remove(e);
			parent.RefreshHostCache();
		}
	}
}
