// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using DGNetwork.Commands;
using DGNetwork.Gui.Dialogs;
using DGNetwork.Services;
using Grunwald.P2PLib.Server;

namespace DGNetwork.DGN.Monitor
{
	public class IPAddressItem : DefaultMonitorItem
	{
		public IPAddressItem()
		{
			this.Title = "${res:DGN.IPAddress}";
			this.Icon = "Icons.IP";
			//this.ContextMenuTreePath = "/Context/Monitor/IPAddress";
			Service.P2P.Server.IPAddressChanged += new EventHandler(OnIPAddressChanged);
			SetText();
		}
		
		public override void Remove()
		{
			Service.P2P.Server.IPAddressChanged -= new EventHandler(OnIPAddressChanged);
			base.Remove();
		}
		
		private void OnIPAddressChanged(object sender, EventArgs e)
		{
			SetText();
		}
		
		private void SetText()
		{
			if (Service.P2P.Server.IPAddress == null)
				this.ValueText = "${res:DGN.IPAddressNotTested}";
			else
				this.ValueText = Service.P2P.Server.IPAddress.ToString();
		}
	}
}
