// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.IO;

namespace DGNetwork.FileTransfer
{
	public interface ITempFileManager
	{
		string GetTempFileName(string filename);
		string GetRelativeName(string absolutePath);
	}
	
	public class DefaultTempFileManager : ITempFileManager
	{
		public string GetTempFileName(string filename)
		{
			return Path.Combine(Helper.GetTempPath(), filename);
		}
		
		public string GetRelativeName(string absolutePath)
		{
			return absolutePath;
		}
	}
}
