// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using Grunwald.Gui;
using DGNetwork.Services;

namespace DGNetwork.Gui
{
	public class DGNTranslator : Translator
	{
		public DGNTranslator()
		{
			Service.Resource.Reloaded += new EventHandler(ResourcesReloaded);
		}
		
		/// <summary>
		/// Translates the specified string.
		/// </summary>
		public override string Translate(string text)
		{
			return Service.Parse(text);
		}
		
		/// <summary>
		/// Gets the text for the default OK button.
		/// </summary>
		public override string OK {
			get {
				return Translate("${res:Global.OK}");
			}
		}
		
		/// <summary>
		/// Gets the text for the cancel button.
		/// </summary>
		public override string Cancel {
			get {
				return Translate("${res:Global.Cancel}");
			}
		}
		
		private void ResourcesReloaded(object sender, EventArgs e)
		{
			this.OnChanged(e);
		}
	}
}
