// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Windows.Forms;

namespace DGNetwork.Gui
{
	public interface IXamlCommand {
		XmlControl XmlControl { get; set; }
		void Handle(object sender, EventArgs e);
	}
	
	public abstract class AbstractXamlCommand : IXamlCommand
	{
		private XmlControl xmlControl;
		
		public XmlControl XmlControl {
			get { return xmlControl; }
			set { xmlControl = value; }
		}
		
		public Control Control {
			get { return xmlControl.Control; }
		}
		
		public Form Form {
			get { return xmlControl.Control as Form; }
		}
		
		public abstract void Handle(object sender, EventArgs e);
	}
}
