// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Collections;

namespace DGNetwork.Search
{
	public interface IManager
	{
		string Icon { get; }
		string Name { get; }
		
		bool SupportsCriteria(ICriteria criteria);
		ISearch BeginSearch(ISearchType searchType);
	}
	
	public abstract class AbstractManager : IManager
	{
		string icon;
		string name;
		
		protected AbstractManager(string icon, string name) {
			this.icon = icon;
			this.name = name;
		}
		
		public string Icon {
			get {
				return icon;
			}
		}
		
		public string Name {
			get {
				return name;
			}
		}
		
		public abstract bool SupportsCriteria(ICriteria criteria);
		public abstract ISearch BeginSearch(ISearchType searchType);
	}
}
