// <file>
//     <copyright see="prj:///doc/copyright.txt"/>
//     <license see="prj:///doc/license.txt"/>
//     <owner name="Mike Krüger" email="mike@icsharpcode.net"/>
//     <version value="$version"/>
// </file>

using System;

namespace DGNetwork.Services
{
	/// <summary>
	/// Is thrown when the GlobalResource manager can't find a requested
	/// resource.
	/// </summary>
	public class ResourceNotFoundException : BaseException
	{
		public ResourceNotFoundException(string resource)
			: base(Service.Resource.GetString("Global.ResourceNotFound", false) + " : " + resource)
		{
		}
	}
}
