// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Collections;
using Grunwald.Gui.Settings;

namespace DGNetwork.Settings
{
	/// <summary>
	/// A setting page representing a network.
	/// </summary>
	public abstract class AbstractNetworkPage : ReflectionSettingPage
	{
		/// <summary>Creates a new instance of the class</summary>
		protected AbstractNetworkPage()
		{
		}
		
		/// <summary>Creates a new instance of the class copying the values from the specified class.</summary>
		protected AbstractNetworkPage(AbstractNetworkPage original) : base(original)
		{
		}
		
		public abstract void CreateNetwork();
		public abstract void DestroyNetwork();
	}
}
