// <file>
//     <copyright see="prj:///doc/copyright.txt"/>
//     <license see="prj:///doc/license.txt"/>
//     <owner name="Mike Krüger" email="mike@icsharpcode.net"/>
//     <version value="$version"/>
// </file>

using System;
using System.IO;
using System.Windows.Forms;
using System.Collections;
using System.Threading;
using System.Resources;
using System.Drawing;
using System.Diagnostics;
using System.Reflection;
using System.Xml;

using ICSharpCode.Core.AddIns;
using ICSharpCode.Core.Properties;


namespace ICSharpCode.Core.Services
{
	/// <include file='ICSharpCode.Core.doc' path='Documentation/Type[@name="ICSharpCode.Core.Services.IService"]/Description/*' />
	public interface IService
	{
		/// <include file='ICSharpCode.Core.doc' path='Documentation/Type[@name="ICSharpCode.Core.Services.IService"]/Member[@name="InitializeService()"]/*' />
		void InitializeService();
		
		/// <include file='ICSharpCode.Core.doc' path='Documentation/Type[@name="ICSharpCode.Core.Services.IService"]/Member[@name="UnloadService()"]/*' />
		void UnloadService();
		
		/// <include file='ICSharpCode.Core.doc' path='Documentation/Type[@name="ICSharpCode.Core.Services.IService"]/Member[@name="Initialize"]/*' />
		event EventHandler Initialize;
		
		/// <include file='ICSharpCode.Core.doc' path='Documentation/Type[@name="ICSharpCode.Core.Services.IService"]/Member[@name="Unload"]/*' />
		event EventHandler Unload;
	}
}
