// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.IO;
using System.Drawing;
using System.Reflection;
using System.Windows.Forms;

namespace Grunwald.Gui.Controls
{
	/// <summary>
	/// A control containing the GNU General Public License.
	/// </summary>
	public class GPLicenseBox : RichTextBox
	{
		/// <summary>
		/// Creates a new RichTextBox.
		/// </summary>
		public GPLicenseBox()
		{
			this.ReadOnly = true;
			this.ScrollBars = RichTextBoxScrollBars.Vertical;
			if (!DesignMode) {
				float oldZoom = this.ZoomFactor;
				Stream s = Assembly.GetExecutingAssembly().GetManifestResourceStream("GPL.rtf");
				if (s == null)
					s = Assembly.GetExecutingAssembly().GetManifestResourceStream("Grunwald.Gui.Controls.GPL.rtf");
				this.LoadFile(s, RichTextBoxStreamType.RichText);
				s.Close();
				this.ZoomFactor = (float)(oldZoom - 0.01);
				// workaround because ZoomFactor has to be changed
				this.ZoomFactor = oldZoom;
			}
		}
	}
}
