// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Runtime.Serialization;

namespace Grunwald.Gui
{
	/// <summary>
	/// Base exception for all custom exceptions thrown by GuiLib.
	/// </summary>
	[Serializable()]
	public class GuiException : ApplicationException
	{
		/// <summary>
		/// Creates a new GuiException.
		/// </summary>
		public GuiException()
			: base()
		{
		}
		
		/// <summary>
		/// Creates a new GuiException.
		/// </summary>
		public GuiException(string message)
			: base(message)
		{
		}
		
		/// <summary>
		/// Creates a new GuiException.
		/// </summary>
		public GuiException(string message, Exception innerException)
			: base(message, innerException)
		{
		}
		
		/// <summary>
		/// Creates a new GuiException.
		/// </summary>
		protected GuiException(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}
	}
}
