// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Runtime.Serialization;

namespace Grunwald.Gui
{
	/// <summary>
	/// This exception is thrown when you access GUI elements from the wrong thread.
	/// Look for 'Invoke' in the Microsoft documentation.
	/// </summary>
	[Serializable()]
	public class InvokeRequiredException : GuiException
	{
		/// <summary>
		/// Creates a new InvokeRequiredException.
		/// </summary>
		public InvokeRequiredException()
			: base("Invoke required")
		{
		}
		
		/// <summary>
		/// Creates a new InvokeRequiredException.
		/// </summary>
		public InvokeRequiredException(string message)
			: base(message)
		{
		}
		
		/// <summary>
		/// Creates a new InvokeRequiredException.
		/// </summary>
		public InvokeRequiredException(string message, Exception innerException)
			: base(message, innerException)
		{
		}
		
		/// <summary>
		/// Creates a new InvokeRequiredException.
		/// </summary>
		protected InvokeRequiredException(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}
	}
}
