// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Runtime.Serialization;

namespace Grunwald.Gui.Settings
{
	/// <summary>
	/// Description of SettingEditException.
	/// </summary>
	[Serializable]
	public class SettingEditException : GuiException
	{
		/// <summary>Creates a new SettingEditException</summary>
		public SettingEditException()
		{
		}
		
		/// <summary>Creates a new SettingEditException</summary>
		public SettingEditException(string message) : base(message)
		{
		}
		
		/// <summary>Creates a new SettingEditException</summary>
		public SettingEditException(string message, Exception innerException) : base(message, innerException)
		{
		}
		
		/// <summary>Creates a new SettingEditException</summary>
		protected SettingEditException(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}
	}
}
