// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Runtime.InteropServices;

namespace Grunwald.Gui
{
	/// <summary>
	/// Win32 PInvoke declarations
	/// </summary>
	internal class Win32
	{
		#region Constants
		public const int EM_GETEVENTMASK = WM_USER + 59;
		public const int EM_SETEVENTMASK = WM_USER + 69;
		
		public const int SBS_HORZ = 0;
		public const int SBS_VERT = 1;
		public const int SB_THUMBPOSITION = 4;
		
		public const int WM_COMMAND = 0x111;
		public const int WM_HSCROLL = 0x114;
		public const int WM_VSCROLL = 0x115;
		public const int WM_MOUSEWHEEL = 0x20A;
		public const int WM_SETREDRAW = 0x00B;
		public const int WM_USER = 0x400;
		#endregion
		
		#region user32.dll
		[DllImport("user32.dll")]
		public static extern bool PostMessageA(IntPtr hwnd, int wMsg, int wParam, int lParam);
		
		[DllImport("user32.dll")]
		public static extern IntPtr SendMessage(IntPtr hWnd, int msg, int wParam, IntPtr lParam);
		
		[DllImport("user32.dll")]
		public static extern IntPtr SendMessage(IntPtr hWnd, int msg, IntPtr wParam, IntPtr lParam);
		
		[DllImport("user32.dll")]
		public static extern int GetScrollPos(IntPtr hWnd, int nBar);
		
		[DllImport("user32.dll")]
		public static extern int GetUpdateRect(IntPtr hwnd, ref RECT rect, bool erase);
		
		[DllImport("user32.dll", SetLastError = true)]
		public static extern bool GetWindowRect(IntPtr handle, ref RECT rect);
		
		[DllImport("user32.dll")]
		public static extern IntPtr BeginPaint(IntPtr hWnd, ref PAINTSTRUCT paintStruct);
		
		[DllImport("user32.dll")]
		public static extern bool EndPaint(IntPtr hWnd, ref PAINTSTRUCT paintStruct);
		#endregion
		
		#region uxtheme.dll
		[DllImport("uxtheme.dll")]
		public static extern bool DrawThemeParentBackground(IntPtr hWnd, IntPtr hdc, ref RECT rct);
		#endregion
	}
	
	[StructLayout(LayoutKind.Sequential)]
	internal struct RECT
	{
		public int left;
		public int top;
		public int right;
		public int bottom;
	}
	
	[StructLayout(LayoutKind.Sequential)]
	internal struct PAINTSTRUCT
	{
		public IntPtr hdc;
		public int fErase;
		public RECT rcPaint;
		public int fRestore;
		public int fIncUpdate;
		public int Reserved1;
		public int Reserved2;
		public int Reserved3;
		public int Reserved4;
		public int Reserved5;
		public int Reserved6;
		public int Reserved7;
		public int Reserved8;
	}
}
