// P2PLib - Copyright (C) 2004-2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;

namespace Grunwald.P2PLib.DGNetwork
{
	/// <summary>
	/// Type of the data packet.
	/// </summary>
	public enum DataBlockType : int
	{
		/// <summary>
		/// The data block simply does nothing (other than keeping the
		/// connection alive).
		/// </summary>
		NoOperation = 0x4e4f4f50,
		/// <summary>
		/// The data block is an update for the routing table.
		/// </summary>
		RoutingTable = 0x524f5554,
		/// <summary>
		/// The data block closes the connection.
		/// The parameter is a UTF-8 string giving the reason.
		/// </summary>
		Quit = 0x51554954,
		/// <summary>
		/// The data block contains a routed packet.
		/// </summary>
		SendPacket = 0x53454e44,
		/// <summary>
		/// The data block contains an answer that reverses the route the original packet
		/// has used.
		/// </summary>
		Answer = 0x414e5357
	}
}
