// P2PLib - Copyright (C) 2004-2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;

namespace Grunwald.P2PLib.DGNetwork
{
	/// <summary>
	/// Status of the net client.
	/// </summary>
	public enum NetClientStatus : int
	{
		/// <summary>
		/// Connecting and sending request (client only)
		/// </summary>
		Connecting,
		/// <summary>
		/// Wait for server response (client only)
		/// </summary>
		WaitForServerResponse,
		/// <summary>
		/// Wait for client response (server only)
		/// </summary>
		WaitForClientResponse,
		/// <summary>
		/// Ready to start receive loop
		/// </summary>
		ReadyForLoop,
		/// <summary>
		/// Connection is ready.
		/// </summary>
		Ready,
		/// <summary>
		/// Connection was closed.
		/// </summary>
		Dead
	}
}
