// P2PLib - Copyright (C) 2004-2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Runtime.Serialization;

namespace Grunwald.P2PLib.DGNetwork
{
	/// <summary>
	/// This exception is thrown when DG Network receives invalid input data.
	/// It causes the connection to close and send the error message as
	/// close reason to the partner.
	/// In debugging mode, the exception is also displayed.
	/// </summary>
	[Serializable()]
	public class ProtocolViolationException : P2PLibException
	{
		/// <summary>
		/// Creates a new ProtocolViolationException.
		/// </summary>
		public ProtocolViolationException()
			: base()
		{
		}
		
		/// <summary>
		/// Creates a new ProtocolViolationException
		/// </summary>
		public ProtocolViolationException(string message)
			: base(message)
		{
		}
		
		/// <summary>
		/// Creates a new ProtocolViolationException.
		/// </summary>
		public ProtocolViolationException(string message, Exception innerException)
			: base(message, innerException)
		{
		}
		
		/// <summary>
		/// Creates a new ProtocolViolationException.
		/// </summary>
		protected ProtocolViolationException(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}
	}
}
