<?php
/////////////////////////////////
////      Installation       ////
/////////////////////////////////
// How to install an ip-server on your web site:
//  YOU NEED:
//   1. PHP-Support
//   2. A MySQL-Database
//  STEPS TO INSTALL:
//   1. Edit the parameters in "Configuration"
//   2. Edit the section "Connect to database" and include the scripts
//       you need on your page to access the database.
//   3. Execute the following SQL-Statement in your database to create the table:
/*
 CREATE TABLE dgnipserver (
  userid INT UNSIGNED NOT NULL,
  ip INT NOT NULL,
  port SMALLINT UNSIGNED NOT NULL,
  pwd CHAR(40) NOT NULL,
  lastaccess INT NOT NULL,
  PRIMARY KEY (userid)
 );
*/
//   4. Upload this page. Now you can use the URL of this page as a URL for
//        Grunwald.P2PLib.DGNetwork.DGNIPServer.
//

/////////////////////////////////
////     Configuration       ////
/////////////////////////////////

$tableName = "dgnipserver"; // the name of the table in the database
$correctIdentifier = "dgn"; // you have to change this line to use the identifier you have choosen for your network

// the connectKey is used by the clients to make sure that no one who has not connected to the IP-Server can connect to the network
// the actual key used is encrypted and changes in the specified interval; but if someone can guess this string, he can calculate the encrypted key on his own.
// the key must be identical on all IP Servers and requires to have the same date on the servers.
$connectKey = "TopSecretKey";
$keychange = "W"; // "m"=montly "W" = Weekly, "d" = daily, "" = every year

// Advanced properties, edit only when you know what you are doing.

// all times are in seconds.
$serverRefreshTime = 250; // time after which the clients that are hosts should refresh this page
$clientRefreshTime = 450; // time after which the clients that aren't hosts should refresh this page
$serverDeadTime = 600; // time after which a server is interpreted as offline
$clientDeadTime = 1000; // time after which a client is interpreted as offline
// the DeadTimes should be at least the double of the refresh time

$deleteUserTime = 3600 * 24 * 7; // time after which the user entry is deleted

$minServerCount = 3; // number of servers the network should have at least. If the server count is below this value, the "wantmore"-Attribute is sent.
$sendServerCount = 15; // this is the maximal number of hosts send to the client

$connectSecureKey = md5($connectKey . date("Y$keychange") . $correctIdentifier);
// the connectSecureKey is used by the clients to make sure that no one who has not connected to the IP-Server can connect to the network
// in connection with date the key is changed every day/month.
// Keep the string secret so the key cannot be calculated for other days/months!!!

/////////////////////////////////
////    Initialize Script    ////
/////////////////////////////////
error_reporting(E_ALL);
header('Content-Type: text/xml');
mt_srand ((double)microtime()*1000000);
$now = time();
echo "<?xml";
?> version="1.0" encoding="utf-8" ?>
<? /*   Update DTD and move it to it's own file when the format is "stable"
<!DOCTYPE note [
<!ELEMENT dgnipserver (status, hosts)>
<!ELEMENT status (ip, time)>
<!ELEMENT ip (#CDATA)>
<!ELEMENT time (#CDATA)>
<!ELEMENT nextrefresh (#CDATA)>
<!ELEMENT hosts (host*)>
<!ATTLIST hosts wantmore (yes|no) "no">
<!ELEMENT host (ip, port)>
]> */?>
<dgnipserver>
<?

/////////////////////////////////
////   Connect to database   ////
/////////////////////////////////

// Note: this is the code I need on my homepage
//  to connect with the database.
// You have to replace my 4 lines with your own code
//  (by including your own file or calling mysql_connect directly)

$pathback=''; 
$nosession = 1;
require('../common.php');
db();

/////////////////////////////////
////      Get Parameters     ////
/////////////////////////////////
// Mandatory parameters:
// pwd=password  # the password used for saving the uid
//   # password is clear text (plain ascii) or somehow encoded, the client may choose
//   # password in database is sha1-coded
//
// Optional parameters:
// uid=id                  # the user-id the client wants to use
// port=(0|port)           # the port where dg network listens as server
// identifier=identifier # the identifier expected for this server. a wrong identifier causes an error.
//   # when port is 0, the user cannot be server.
if (!isset($_GET['pwd'])) {
	print("<error>The needed attribute 'pwd' was not specified. This page is intended for use with the DG Network chat program.\n");
	print("If you are viewing it in a browser, goto http://www.danielgrunwald.de/network/ for more information.</error>\n");
	print("</dgnipserver>");
	exit;
}
$pwd = $_GET['pwd'];
$dbpwd = sha1($pwd);

$servercode = md5("{$_SERVER['SERVER_NAME']}:{$_SERVER['SERVER_PORT']}/{$_SERVER['SCRIPT_FILENAME']}?{$correctIdentifier}");
$minUserId = hexdec(substr($servercode, 0, 4)) * 10000 + 1;
$maxUserId = $minUserId + 10000;

if (isset($_GET['uid'])) {
	$uid = (int)$_GET['uid'];
} else {
	$uid = mt_rand($minUserId, $maxUserId);
}
if (isset($_GET['port'])) {
	$port = (int)$_GET['port'];
	if ($port < 0)
		$port = 0;
} else {
	$port = 0;
}
if (isset($_GET['identifier'])) {
	if ($_GET['identifier'] != $correctIdentifier)
		die("<error>The specified identifier is not accepted on this server.</error></dgnipserver>");
}

if ($uid < $minUserId || $uid > $maxUserId)
	$uid = mt_rand($minUserId, $maxUserId);

/////////////////////////////////
////  Test/Register Userid   ////
/////////////////////////////////
$retry = 0;
$ok = 0;
do {
	$retry += 1;
	$sql = "SELECT * FROM $tableName "
		. "WHERE userid = '$uid';";
	$result = mysql_query($sql);
	if ($arr = mysql_fetch_assoc($result)) {
		if ($arr['pwd'] == $dbpwd) {
			$ok = 1;
		} else {
			$uid = mt_rand($minUserId, $maxUserId);
		}
	} else {
		$sql = "DELETE FROM $tableName "
			. "WHERE lastaccess < ($now - $deleteUserTime)";
		mysql_query($sql);
		$sql = "INSERT INTO $tableName "
			. "(userid, pwd, ip, port, lastaccess) "
			. "VALUES ('$uid', '$dbpwd', '0', '0', '0')";
		mysql_query($sql);
	}
} while($ok == 0 && $retry < 30);
if ($ok == 0) die("<error>internal server error</error></dgnipserver>");

/////////////////////////////////
//// Update user information ////
/////////////////////////////////
$iplong = ip2long($_SERVER["REMOTE_ADDR"]);
$sql = "UPDATE $tableName "
	. "SET ip = '$iplong', "
	.   "port = '$port', "
	.  "lastaccess = '$now' "
	. "WHERE userid = '$uid' AND pwd = '$dbpwd';";
mysql_query($sql);

/////////////////////////////////
////    Send XML document    ////
/////////////////////////////////


?>
  <status>
    <ip><? echo $_SERVER["REMOTE_ADDR"]; ?></ip>
    <time><? echo $now; ?></time>
    <? if (!isset($_GET['identifier'])) echo "<identifier>$correctIdentifier</identifier>"; ?>
    <nextrefresh><? echo $serverRefreshTime; ?></nextrefresh>
<?
	if ($connectSecureKey != "") {
		print("  <connectkey>$connectSecureKey</connectkey>\n");
	}
	print("    <yourid>$uid</yourid>");
?>
  </status>
  <hosts>
<?
$sql = "SELECT userid, ip, port FROM $tableName "
	. "WHERE (port > 0) "
	.   "AND (($now - lastaccess) < $serverDeadTime) "
	.   "AND (userid != '$uid') "
	. "ORDER BY ($now-lastaccess) DESC "
	. "LIMIT 0,$sendServerCount;";
$result = mysql_query($sql);
while($arr = mysql_fetch_assoc($result)) {
	$hostid = $arr['userid'];
	$hostip = long2ip($arr['ip']);
	$hostport = $arr['port'];
	print("    <host userid=\"$hostid\">$hostip:$hostport</host>\n");
}
?>
  </hosts>
</dgnipserver>
