// P2PLib - Copyright (C) 2004-2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Security.Cryptography;
using NUnit.Framework;

namespace Grunwald.P2PLib.Tests.DGNetwork
{
	[TestFixture]
	public class EncryptionTest
	{
		[Test]
		public void IdentityImportKey512()
		{
			IdentityTest(512);
		}
		
		[Test]
		public void IdentityImportKey1024()
		{
			IdentityTest(1024);
		}
		
		[Test]
		public void IdentityImportKey2048()
		{
			IdentityTest(2048);
		}
		
		void IdentityTest(int keySize) {
			Identity ident = new Identity(keySize);
			Identity ident2 = new Identity(ident.PublicKey);
			if (ident.PublicKey != ident2.PublicKey)
				throw new AssertionException("Identity failed importing " + keySize.ToString() +
				                             " bit key.");
		}
	}
}
