// P2PLib - Copyright (C) 2004-2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.IO;
using log4net.Config;

namespace Grunwald.P2PLib.Tests
{
	public class MainClass
	{
		public const string TestDataDir = "../../data/testdata/";
		
		static bool initOK = false;
		
		public static void Init()
		{
			if (initOK)
				return;
			FileInfo file = new FileInfo("./Log4Net.Config.xml");
			if (!file.Exists)
				file = new FileInfo("./../Grunwald.P2PLib.Tests/Log4Net.Config.xml");
			if (!file.Exists)
				file = new FileInfo("./../../Grunwald.P2PLib.Tests/Log4Net.Config.xml");
			if (!file.Exists)
				throw new FileNotFoundException("Log4Net.Config.xml not found", "Log4Net.Config.xml");
			initOK = true;
			XmlConfigurator.Configure(file);
		}
	}
}
