// P2PLib - Copyright (C) 2004-2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.IO;
using Grunwald.P2PLib.Server;

namespace Grunwald.P2PLib.Tests
{
	public class LocalConnection : TcpConnection
	{
		public static void Create(out LocalConnection c1, out LocalConnection c2)
		{
			PartnerStream s1, s2;
			PartnerStream.Create(out s1, out s2);
			c1 = new LocalConnection(s1);
			c2 = new LocalConnection(s2);
		}
		
		protected LocalConnection(Stream stream) : base(stream)
		{
		}
		
		bool open = true;
		public override void Close()
		{
			open = false;
			base.Reader.Close();
			base.Writer.Close();
			base.Stream.Close();
		}
		
		public override bool Connected {
			get { return open; }
		}
	}
}
