// P2PLib - Copyright (C) 2004-2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Runtime.Serialization;

namespace Grunwald.P2PLib
{
	/// <summary>
	/// This exception is used when a connection cannot be build.
	/// </summary>
	[Serializable()]
	public class BuildConnectionException : P2PLibException
	{
		/// <summary>
		/// Creates a new BuildConnectionException.
		/// </summary>
		public BuildConnectionException()
			: base()
		{
		}
		
		/// <summary>
		/// Creates a new BuildConnectionException
		/// </summary>
		public BuildConnectionException(string message)
			: base(message)
		{
		}
		
		/// <summary>
		/// Creates a new BuildConnectionException.
		/// </summary>
		public BuildConnectionException(string message, Exception innerException)
			: base(message, innerException)
		{
		}
		
		/// <summary>
		/// Creates a new BuildConnectionException.
		/// </summary>
		protected BuildConnectionException(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}
	}
}
