// P2PLib - Copyright (C) 2004-2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;

namespace Grunwald.P2PLib.Network
{
	/// <summary>
	/// Event handler for P2PNetwork.ConnectionAdded / ConnectionRemoved events.
	/// </summary>
	public delegate void ConnectionEventHandler(object sender, ConnectionEventArgs e);
	
	/// <summary>
	/// Event args class for P2PNetwork.ConnectionAdded / ConnectionRemoved events.
	/// </summary>
	public class ConnectionEventArgs : EventArgs
	{
		Connection connection;
		
		/// <summary>
		/// Gets the affected connection.
		/// </summary>
		public Connection Connection {
			get {
				return connection;
			}
		}
		
		/// <summary>
		/// Creates a new instance of the <see cref="ConnectionEventArgs"/> class.
		/// </summary>
		/// <param name="connection">The affected connection.</param>
		public ConnectionEventArgs(Connection connection) {
			this.connection = connection;
		}
	}
}
