// P2PLib - Copyright (C) 2004-2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Runtime.Serialization;

namespace Grunwald.P2PLib
{
	/// <summary>
	/// Class for all custom exceptions thrown by the P2PLib.
	/// </summary>
	[Serializable()]
	public class P2PLibException : ApplicationException
	{
		/// <summary>
		/// Creates a new P2PLibException.
		/// </summary>
		public P2PLibException()
			: base()
		{
		}
		
		/// <summary>
		/// Creates a new P2PLibException
		/// </summary>
		public P2PLibException(string message)
			: base(message)
		{
		}
		
		/// <summary>
		/// Creates a new P2PLibException.
		/// </summary>
		public P2PLibException(string message, Exception innerException)
			: base(message, innerException)
		{
		}
		
		/// <summary>
		/// Creates a new P2PLibException.
		/// </summary>
		protected P2PLibException(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}
	}
}
