// P2PLib - Copyright (C) 2004-2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;

namespace Grunwald.P2PLib.Server.Http
{
	/// <summary>
	/// This server is just a HTTPServer with a preinstalled HTTPConnectionHandler.
	/// </summary>
	public class HttpServer : HttpLikeServer
	{
		HttpConnectionHandler handler = new HttpConnectionHandler();
		
		/// <summary>
		/// Creates a new HTTPServer with a <see cref="HttpConnectionHandler"/>.
		/// </summary>
		public HttpServer()
		{
			base.ConnectionHandlers.Add(handler);
		}
		
		/// <summary>
		/// The collection of <see cref="IRequestHandler">RequestHandlers</see> that can
		/// handle HTTP requests.
		/// </summary>
		/// <remarks>This property returns the same reference as this server's
		/// <see cref="HttpConnectionHandler"/>.</remarks>
		public RequestHandlerCollection RequestHandlers {
			get { return handler.RequestHandlers; }
		}
	}
}
