// P2PLib - Copyright (C) 2004-2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Collections.Specialized;

namespace Grunwald.P2PLib.Server
{
	/// <summary>
	/// Implement this interface to extend the HTTPLikeServer with protocols.
	/// </summary>
	public interface IConnectionHandler
	{
		/// <summary>
		/// Handles the given connection
		/// </summary>
		void Handle(IConnection connection, StringCollection request);
		
		/// <summary>
		/// Gets the priority this ConnectionHandler has for the given request.
		/// The ConnectionHandler that returns the highest priority will handle the
		/// request.
		/// </summary>
		int GetPriority(StringCollection request);
	}
}
