// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using log4net;
using log4net.Core;
using log4net.Appender;
using DGNetwork.Services;
using ICSharpCode.Core.Services;

namespace DGNetwork.StartUp
{
	public class Listener : AppenderSkeleton
	{
		protected override void Append(LoggingEvent loggingEvent)
		{
			new void_LoggingEvent(ShowEvent).BeginInvoke(loggingEvent, null, null);
		}
		
		private delegate void void_LoggingEvent(LoggingEvent loggingEvent);
		
		void ShowEvent(LoggingEvent loggingEvent)
		{
			try {
				if (loggingEvent.MessageObject is Exception) {
					Service.Message.ShowError((Exception)loggingEvent.MessageObject);
				} else if (loggingEvent.Level > Level.Error) {
					Service.Message.ShowError(loggingEvent.RenderedMessage);
				} else if (loggingEvent.Level > Level.Warn) {
					Service.Message.ShowWarning(loggingEvent.RenderedMessage);
				} else {
					Service.Message.ShowMessage(loggingEvent.RenderedMessage);
				}
			} catch (Exception ex) {
				Console.WriteLine(ex);
				Console.WriteLine(loggingEvent.RenderedMessage);
				System.Windows.Forms.MessageBox.Show(ex.ToString());
				System.Windows.Forms.MessageBox.Show(loggingEvent.RenderedMessage);
			}
		}
	}
}
