// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Collections;
using System.IO;
using System.Drawing;
using System.Reflection;
using Grunwald.Gui.Settings;

namespace TCPSniffer
{
	public class FilterIcons
	{
		static Hashtable cache = new Hashtable();
		public static Image GetIcon(string name)
		{
			lock(cache) {
				Image image = (Image)cache[name];
				if (image == null) {
					using (Stream s = Assembly.GetExecutingAssembly().GetManifestResourceStream(name + ".ico")) {
						using (Icon ico = new Icon(s, 16, 16)) {
							image = Grunwald.Gui.Components.IconLoader.IconToBitmap(ico);
							cache[name] = image;
						}
					}
				}
				return image;
			}
		}
	}
}
