// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;

namespace TCPSniffer
{
	public class InfoForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.LinkLabel linkLabel1;
		private Grunwald.Gui.Controls.GPLicenseBox gPLicenseBox1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label versionLabel;
		private System.Windows.Forms.LinkLabel linkLabel;
		private System.Windows.Forms.Label label1;
		private Grunwald.Gui.Controls.AutoSizedButton okButton;
		
		public InfoForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			this.Icon = SystemIcons.Information;
			string exeName = System.Reflection.Assembly.GetExecutingAssembly().Location;
			FileVersionInfo ver = FileVersionInfo.GetVersionInfo(exeName);
			versionLabel.Text += string.Format("{0}.{1}.{2}.{3}", ver.FileMajorPart, ver.FileMinorPart, ver.FileBuildPart, ver.FilePrivatePart);
			#if WithoutDGN
			#else
			versionLabel.Text += " + DG Network";
			#endif
			#if WithoutOscar
			#else
			versionLabel.Text += " + Oscar";
			#endif
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.okButton = new Grunwald.Gui.Controls.AutoSizedButton();
			this.label1 = new System.Windows.Forms.Label();
			this.linkLabel = new System.Windows.Forms.LinkLabel();
			this.versionLabel = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.gPLicenseBox1 = new Grunwald.Gui.Controls.GPLicenseBox();
			this.linkLabel1 = new System.Windows.Forms.LinkLabel();
			this.SuspendLayout();
			// 
			// okButton
			// 
			this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.okButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.okButton.Location = new System.Drawing.Point(408, 432);
			this.okButton.Name = "okButton";
			this.okButton.Size = new System.Drawing.Size(75, 24);
			this.okButton.TabIndex = 0;
			this.okButton.Text = "OK";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 48);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(472, 16);
			this.label1.TabIndex = 7;
			this.label1.Text = "TCPSniffer is written by Daniel Grunwald.";
			// 
			// linkLabel
			// 
			this.linkLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
						| System.Windows.Forms.AnchorStyles.Right)));
			this.linkLabel.LinkArea = new System.Windows.Forms.LinkArea(89, 31);
			this.linkLabel.Location = new System.Drawing.Point(8, 8);
			this.linkLabel.Name = "linkLabel";
			this.linkLabel.Size = new System.Drawing.Size(480, 40);
			this.linkLabel.TabIndex = 1;
			this.linkLabel.TabStop = true;
			this.linkLabel.Text = "TCPSniffer is a IP capturing tool developed for debugging DG Network. It is based" +
" on the PacketMonitor from Mentalis.org, but most parts have been rewritten.";
			this.linkLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.LinkLabelLinkClicked);
			// 
			// versionLabel
			// 
			this.versionLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
						| System.Windows.Forms.AnchorStyles.Right)));
			this.versionLabel.Location = new System.Drawing.Point(8, 440);
			this.versionLabel.Name = "versionLabel";
			this.versionLabel.Size = new System.Drawing.Size(384, 16);
			this.versionLabel.TabIndex = 6;
			this.versionLabel.Text = "TCP Sniffer Version ";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(464, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "License of TCPSniffer, DG Network, and the P2PLib:";
			// 
			// gPLicenseBox1
			// 
			this.gPLicenseBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
						| System.Windows.Forms.AnchorStyles.Left) 
						| System.Windows.Forms.AnchorStyles.Right)));
			this.gPLicenseBox1.Location = new System.Drawing.Point(8, 112);
			this.gPLicenseBox1.Name = "gPLicenseBox1";
			this.gPLicenseBox1.ReadOnly = true;
			this.gPLicenseBox1.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Vertical;
			this.gPLicenseBox1.Size = new System.Drawing.Size(480, 312);
			this.gPLicenseBox1.TabIndex = 5;
			this.gPLicenseBox1.Text = "GNU GENERAL PUBLIC LICENSE";
			this.gPLicenseBox1.ZoomFactor = 0.8000488F;
			// 
			// linkLabel1
			// 
			this.linkLabel1.Location = new System.Drawing.Point(56, 64);
			this.linkLabel1.Name = "linkLabel1";
			this.linkLabel1.Size = new System.Drawing.Size(360, 16);
			this.linkLabel1.TabIndex = 8;
			this.linkLabel1.TabStop = true;
			this.linkLabel1.Text = "http://www.danielgrunwald.de";
			this.linkLabel1.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.LinkLabel1LinkClicked);
			// 
			// InfoForm
			// 
			this.AcceptButton = this.okButton;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(496, 462);
			this.Controls.Add(this.linkLabel1);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.versionLabel);
			this.Controls.Add(this.gPLicenseBox1);
			this.Controls.Add(this.okButton);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.linkLabel);
			this.MinimumSize = new System.Drawing.Size(384, 320);
			this.Name = "InfoForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "TCPSniffer - Information";
			this.ResumeLayout(false);
		}
		#endregion
		
		void LinkLabelLinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			try {
				Process.Start("http://www.mentalis.org/soft/projects/pmon/");
			} catch (Exception ex) {
				MessageBox.Show(ex.Message);
			}
		}
		void LinkLabel1LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			try {
				Process.Start("http://www.danielgrunwald.de/");
			} catch (Exception ex) {
				MessageBox.Show(ex.Message);
			}
		}
	}
}
