// Copyright (C) 2005  Daniel Grunwald
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// For more information read the file "LICENSE.txt".

using System;
using System.Windows.Forms;

namespace TCPSniffer
{
	public class TreeNodeFactory
	{
		public TreeNode Create(string text, int from, int length)
		{
			TreeNode node = new TreeNode(text);
			node.Tag = new Range(from, length);
			return node;
		}
	}
	
	public class Range
	{
		int start;
		int length;
		
		public Range(int start, int length)
		{
			this.start = start;
			this.length = length;
		}
		
		public int Start {
			get {
				return start;
			}
		}
		
		public int Length {
			get {
				return length;
			}
		}
		
		public int End {
			get {
				return start + length;
			}
		}
	}
}
