﻿//** Grunwald.P2PLib.Server.Http.HttpServer
//** Grunwald.P2PLib.Server.Http.IRequestHandler
//** Grunwald.P2PLib.Server.Http.HttpConnectionHandler
//// You can use the HttpServer like this:
using System;
using Grunwald.P2PLib.Server;
using Grunwald.P2PLib.Server.Http;

public class MainClass
{
	public static void Main()
	{
		HttpServer server = new HttpServer();
		server.Port = 80; // change the port if necessary.
		server.RequestHandlers.Add(new MyRequestHandler());
		server.Start();
		// now the server waits for connections
		try {
			System.Diagnostics.Process.Start("http://localhost:" + server.Port.ToString() + "/");
		} catch {
			// ignore browser errors
		}
		Console.WriteLine("Press enter to exit the server.");
		Console.ReadLine();
		server.Stop();
	}
}

public class MyRequestHandler : IRequestHandler
{
	public void Handle(HttpRequest request)
	{
		HttpResponse response = new HttpResponse(request);
		string txt = "<html><head><title>Own Server</title></head>" +
			"<body>This is the answer of your self-made server." +
			"<br>The requested file was: '" + request.File + "'.</body></html>";
		
		response.ContentLength = txt.Length;
		response.ContentType = "text/html";
		response.Server = "Your own HTTP server";
		response.SendHeaders(request.Connection.Writer, false);
		request.Connection.Writer.Write(txt);
		request.Connection.Writer.Flush();
	}
	
	public int GetPriority(HttpRequest request)
	{
		return 1; // accept every request
	}
}

